/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.util.MetaNav");

dojo.require("com.ibm.team.dashboard.web.ui.internal.MetaNav");
dojo.require("com.ibm.rqm.planning.web.ui.internal.dnd.DraggableTabs");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");

(function() {
var DraggableTabs = com.ibm.rqm.planning.web.ui.internal.dnd.DraggableTabs;
var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.util.MetaNav", 
				  com.ibm.team.dashboard.web.ui.internal.MetaNav, 
{
	init: function(args) {		
/*		if (this.isInitialized) {
			return;
		}
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.serverError, this, "_showErrorMessage");
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.hideServerError, this, "hideMessage");
		
		this.dashboardItem = this.dashboardContainer.getDashboardItem();
		this._dashboardInfo = this.dashboardContainer.getDashboardInfo();
		this.viewletPageHelpers = args.viewletPageHelpers;
		
		if (!this.dashboardContainer.isPrivateContributorDashboard())
			this._addBreadcrumbs(this.dashboardItem);
		else {
			this._breadcrumbs.style.display = "none";
			this._tabWrapper.style.marginTop = "3px";
		}
		
		this.title.value = args.title;
		this.title.domNode.innerHTML = args.title;
		dojo.removeClass(this.title.domNode, "loading-title");
		//create new DraggableTabs container
		var div = document.createElement("div");
		this._tabs.appendChild(div);
		this.draggableTabs = new DraggableTabs(div,{parent: this, accept: ["tab"], selectedTabId: args.selectedTabId, dashboardContainer: this.dashboardContainer, dashboardItem: this.dashboardItem, dashboardInfo: this._dashboardInfo});
		for (var i=0; i<this.viewletPageHelpers.length; i++) {
			var viewletPageHelper = this.viewletPageHelpers[i];
			var id = viewletPageHelper.id;
			this.draggableTabs.add(null,{title: viewletPageHelper.title, id: id, index: i, helper: viewletPageHelper, type: "tab"});
		}
		this._tabWrapper.style.display = "block";
		this.draggableTabs.startup(); */
		
		if (this.isInitialized) {
			return;
		}
		
		//set dashboardBundle and setup other useful pointers
		this.dashboardBundle = args.dashboardBundle;
		this.dashboardItem = this.dashboardBundle.dashboard;
		this.dashboardContainer = args.dashboardContainer;
		
		this._dashboardTitle.innerHTML = "";
		dojo.removeClass(this._dashboardTitle, "loading-title");
		
		this._refreshEvent = dojo.connect(this.refreshButton,"onclick",this.dashboardContainer,this.dashboardContainer.refresh);
		this.setEditMode(args.editMode);
		
		//initialize publish API for showing/hiding the message area (info, error, warning)
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.serverError, this, "_showErrorMessage");
		dojo.subscribe(com.ibm.team.dashboard.web.ui.internal.Constants.hideServerError, this, "hideMessage");
		
		var perms = this.dashboardBundle.permissions;
		if (!this.dashboardContainer.isPrivateContributorDashboard() && (perms.viewTeam || perms.viewPersonal || perms.viewProfile))
			this._addBreadcrumbs(this.dashboardItem);
		else {
			this._breadcrumbs.style.display = "none";
			this.dashboardContainer._tabWrapper.style.marginTop = "3px";
		}
	
		// show a notice if scope item is archived
		if (this.dashboardBundle.isScopeArchived) {
			var msg;
			var scope = this.dashboardItem.scope;
			switch(scope) {
				case DashboardConstants.SCOPE_CONTRIBUTOR:
					msg = messages.archivedContributor;
					break;
				case DashboardConstants.SCOPE_TEAM_AREA:
					msg = messages.archivedTeam;
					break;
				case DashboardConstants.SCOPE_PROJECT_AREA:
					msg = messages.archivedProject;
					break;
			}
			this.showMessage({type: "info", message: msg});
		}

	}
});

})();
