/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() 
{
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
				this._loadClassAsync("com.ibm.rqm.defects.web.client.ChangeRequestManager", null);
				this._loadClassAsync("com.ibm.rqm.defects.web.helper.RemoteItemPicker", null);
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.DefectsActionBarEntry.superclass.initialize.call(this, args);
				this.inherited('initialize', arguments);
				
                var page = PageRegistry.findPageWithId("com.ibm.team.workitem");
                var cqPage = PageRegistry.findPageWithId("com.ibm.rational.cm");
				this._jazzPageUri = (page) ? page.getUri() : "";
				this._cqPageUri = (cqPage) ? cqPage.getUri() : "";
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelCreateDefect"), dojo.hitch(this, "_onClickCreateDefect"), false, null);
				this._addNonDispatchableMenuEntry(Constants.getMessage("labelGoToDefects"), dojo.hitch(this, "_onClickDefects"), false, null);
			},
			
			_onClickCreateDefect: function()
			{
				com.ibm.rqm.defects.web.client.ChangeRequestManager.getInstance().getCurrentServiceProvider(function(currentServiceProvider) {
					if (currentServiceProvider) {
	                    var creationDialogUri = currentServiceProvider.providerUris.defaultCreationDialogURI;
	                    var params = {
	                        dialogTitle: Constants.getMessage("labelCreateDefect"),
	                        secondaryTitle: Constants.getMessage("labelAddNewDefect"),
	                        pickerURL: creationDialogUri,
	                        height: currentServiceProvider.providerUris.creationDialog.height,
                        	width: currentServiceProvider.providerUris.creationDialog.width,
	                        parentElement: this.domNode,
	                        onOk: function(selectedItems){
	                            //do nothing
	                        },
	                        onClose: function(){
	                        }
	                    };
	                    new com.ibm.rqm.defects.web.helper.RemoteItemPicker(params);
	                }
	                else {
	                    // No cm service provider is configured.
						var uniqueId = Date.parse(new Date().toString());
	                    window.location.hash = "action=com.ibm.team.workitem.newWorkItem&type=defect&ts=" + uniqueId;
	                }
						
				});
			},
			
			_onClickDefects: function()
			{
				var self = this;
				com.ibm.rqm.defects.web.client.ChangeRequestManager.getInstance().getServiceProviders(function(serviceProviders) {
					var isClearQuestProviderConfigured = false;
					dojo.forEach(serviceProviders, function(serviceProvider) {
						if (serviceProvider.servicesUrl.indexOf("cqrest") != -1) {
                            isClearQuestProviderConfigured = true;
                        }
					});
					if (isClearQuestProviderConfigured) {
	                    window.location.hash = self._cqPageUri;
	                }
	                else {
	                    // No cm service provider is configured.
	                    window.location.hash = self._jazzPageUri;
	                }
						
				});
			}
		}
	);
}
)();
