//debug ListCellWidget
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
     
       
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget");



dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");


(function() {

var Constants = com.ibm.rqm.planning.web.client.internal.Constants;


com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidgetAction = {
	ADD : "add",
	REMOVE : "remove",
	CLOSE : "close"
};

var ListCellWidgetAction = com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidgetAction;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.ListCellWidget", [dijit._Widget, dijit._Templated], {
	_select: null,
	_cellData: null,
	_validateCallback: null,
	_changedCallback: null,
	_rowobject: null,
	_error: "",
    _value: Constants.getMessage("labelValue"),
    _colon: Constants.getMessage("labelColen"),
		templateString: '<div style="width:25em" dojoAttachPoint="_toplevelNode" >' + 
					'          <div style="float: left; width: 70%">' +
                    '			   <div dojoAttachPoint="_listboxNode"></div>' +
					'              <div style="float: left;">${_value}${_colon}</div>'+										
				    '              <div style="float: right;" dojoAttachPoint="_inputNode"></div>'+
					'          </div>' +
					'          <div style="float: right;">' +
					'	            <div dojoAttachPoint="_closeNode" class="button"></div>' +					
					'	            <div dojoAttachPoint="_addNode" class="button"></div>' +
					'			    <div dojoAttachPoint="_removeNode" class="button"></div>' + 
					'          </div>'  +
					'          <div style="clear: left;" dojoAttachPoint="_validationNode" class="com-ibm-asq-listcellwidget-text-error" ></div>' +
                    '</div>',
					
    constructor: function(args) {
  		this._validateCallback = args.validateCallback;
		this._changedCallback = args.changedCallback;
		this._cellData = args.cellData; 
	},

    postCreate: function(){
        this.inherited('postCreate', arguments);
		
		var argAdd = {
            label: Constants.getMessage("labelAdd"),
			iconClass: "add-icon-image",						
            showLabel: true,
            parent: this,
            onClick: dojo.hitch(this, "_onAdd")
        };		
		var argClose = {
            label: Constants.getMessage("labelCollapse"),
            showLabel: true,
			iconClass: "collapse-icon-image",
            parent: this,
            onClick: dojo.hitch(this, "_onClose")
        };
		var argRemove = {
            label: Constants.getMessage("labelRemove"),
            showLabel: true,
			iconClass: "delete-icon-image",
            parent: this,
            onClick: dojo.hitch(this, "_onRemove")
        };
        removeButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(argRemove);
        addButton =    new com.ibm.asq.common.web.ui.internal.widgets.Button(argAdd);
        closeButton =  new com.ibm.asq.common.web.ui.internal.widgets.Button(argClose);		
				 
				
		this._select = document.createElement("select");
		this._select.className = "com-ibm-asq-listcellwidget-text-normal";
		this._listboxNode.appendChild(this._select);
		this._select.multiple = "yes";
		this._select.size = 5;
		for (var i = 0; i < this._cellData.length; i++) {
			this._select.options[i] = new Option(this._cellData[i], i);
		}
				
		
		this._input = document.createElement("input");
		this._input.rowObject = this.rowObject;
		this._input.className = ".com-ibm-asq-listcellwidget-text-normal";
		this._input.onkeyup = dojo.hitch(this, "onkeyup");		
		
		this._inputNode.appendChild(this._input);
		this._closeNode.appendChild(closeButton.domNode);					
		this._addNode.appendChild(addButton.domNode);			
		this._removeNode.appendChild(removeButton.domNode);

    },
	
	onkeyup: function(ch)
	{
		if(ch.keyCode == dojo.keys.ENTER)
		 	this._onAdd();
 	},
	
	_onValidate: function(oldList, newList, action){
		this._validationNode.innerHTML = "";						
		return this._validateCallback(oldList, newList, action, this.rowObject);
	},
	
	_onChanged: function(oldList, newList, action){
		return this._changedCallback(oldList, newList, action, this.rowObject);
	},
		
	_onRemove: function(){
		var rc;

		if(this._select){
			rc = this._onValidate(null, this._getSelectionList(), ListCellWidgetAction.REMOVE);
			if(rc.valid){
				this._onChanged(null, this._getSelectionList(), ListCellWidgetAction.REMOVE);
				for (var i = this._select.options.length - 1; i >= 0; i--) {
					if(this._select.options[i].selected){
						for(var j = i; j < this._select.options.length - 1; j++)
							this._select.options[j].text = this._select.options[j + 1].text;
						this._select.options[this._select.options.length - 1] = null;
					}
			 	}
			 }
			 else
		 		this._validationNode.innerHTML = rc.reason;
		}
	},
	
	_onClose: function(){
			this._onValidate(null, null, null, null, ListCellWidgetAction.CLOSE)		
			this._onChanged(null, null, ListCellWidgetAction.CLOSE, null);
	},
	
	_onAdd: function(){
		var text = this._input.value;
		this._validationNode.innerHTML = "";				
		var rc = this._onValidate(null, text, ListCellWidgetAction.ADD);
		if(rc.valid){
			this._onChanged(null, text, ListCellWidgetAction.ADD);
			this._select.options[this._select.options.length] = new Option(text, text);
			this._input.value = "";
		}
		else	
			this._validationNode.innerHTML = rc.reason;
	},
	
	_getSelectionList: function()
	{
		var list = new Array();
		for (var i = 0; i < this._select.options.length; i++){
			if(this._select.options[i].selected){
				list.push(this._select.options[i].text);
			}
	 	}
		return list;
	}
});
})();