/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");

dojo.require("dojo.parser");
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._editor.plugins.AlwaysShowToolbar");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("jazz.ui.HoverPopup");
dojo.require("dijit._editor.html");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("dojox.layout.ResizeHandle");


(function() { // module container

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var DOWNLOAD_SERVICE_URI 	= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var HoverPopup 				= jazz.ui.HoverPopup;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

/* QM objects */
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var RegistryClient 			= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Editor 					= com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var SelectUtility 			= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var COMMENT_VIEW_TYPE		= "commentView";
var ATTACHMENT_VIEW_TYPE	= "attachmentView";
var COMPARE_VIEW_TYPE		= "compareView";
var ResizeHandle			= dojox.layout.ResizeHandle;

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/ExecutionScriptElementList.html"),
		labelExpectedResult: Constants.getMessage("labelExpectedResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelStep: Constants.getMessage("labelStep"),
		labelComments:Constants.getMessage("labelComments"),
		
		// object initializer
		widgetsInTemplate: true,
		constructor: function(args){
			this._steps = [];
			this._elementTypes = [];
			this.lastClickedRow = "none";
			this.prevStepNum = -1;
			this.scriptObjects = [];
			if(args.save){
				this.save = args.save;
			}
		},

		postCreate: function() { 
			this.DEFAULT_STEP_TYPE = "Execution Step";
			this.expectedResult_Summary_ID = "_stepSummaryExpectedResult_";
			this.expectedResult_ID = "expectedResult_";
			this.ID_SUMMARY_ROW = this.id+"row_summary_step_";
			this.ID_EDITOR = this.id+"__stepEditor";
			this.ID_DETAIL_EDITOR_DIV = this.id+"row_detail_editor_div_";
			this.ID_EXPECTED_RES_DIV = this.id+this.expectedResult_ID;
			this.ID_TYPE_DROPDOWN = this.id+"dropdownIcon";
			this.ID_TYPE_DROPDOWN2 = this.id+"dropdownIcon2_";
			this.ID_STEP_TYPE = this.id+"_stepType";
			this.ID_KW_TYPE = this.id+"_kwType";
			this.ID_STEP_SUMMARY = this.id+"_stepSummary_";
			this.ID_STEP_SUMMARY_EXP = this.id+this.expectedResult_Summary_ID;
			this.ID_KW_SUMMARY_CELL = this.id+"_kwSummaryCell";
			this.ID_KW_SUMMARY_EXP_CELL = this.id+"_kwExpectedCell";
			this.ID_KW_SUMMARY = this.id+"_kwSummary";
			this.ID_KW_SUMMARY_EXP = this.id+"_kwExpected";
			this.ID_ATTACH_CELL = this.id+"_attachCell";
			this.ID_COMMENT_CELL = this.id+"_commentCell";
			this.ID_COMMENT_COL_AREA = this.id+"_commentColArea";
			this.ID_COMMENT_COL_CELL = this.id+"_commentColCell";
			this.ID_COMPARE_CELL = this.id+"_compareCell";
			this._tooltips = [];
			this.attachingEditor = false;
			this.labelStep = Constants.getMessage("labelStep");
			this.imageDisplayType = "";
			this.showCommentsCol = false;
			this.showCompactView = false;
			this.keywordStepsCounter = 0;
			this.onmousemoveEvent = [];
		},
		
		initialize: function(args) {
			if (args.parentController == null) {
				throw new Error("ExecutionScriptElementList#initialize: Missing required parameter 'parentController'");
			}
			this._steps = [];
			if ( args.steps != null && args.steps.length > 0 ) {
				for (var i = 0; i < args.steps.length; i++) {
					this._steps.push(args.steps[i]);
				}				
			}	
			if(args.parentCallBack)
				this.parentCallBack = args.parentCallBack;		
			this._initElementTypes();
			this._createSplitContainer();
            this.dndTopic = dojo.subscribe("/dnd/drop",this, "_dndDrop");
			this.dndTopic2 = dojo.subscribe("/dnd/cancel",this,"_dndCancel");            
		},	
		
		isReadOnly: function() {
			if ((this.parentCallBack && dojo.isFunction(this.parentCallBack.isReadOnly))) {
				return this.parentCallBack.isReadOnly();
			}
			return false; //default to non read only mode
		},
		_dndCancel:function(){
			if(!dojo.isIE)
				document.body.style.cursor = "default";
		},
        _dndDrop:function(source,nodes,iscopy,target){
			if(!dojo.isIE)
				document.body.style.cursor = "default";
			if(source){
               if(nodes[0]["editorId"]){
				   	if(nodes[0]["editorId"] != this.id) // the keyword drop isnt meant for me
	                    return;
	                var row = target.anchor.nextSibling;
					if(!row)
						row = target.anchor.previousSibling;
					if(row){
						dojo.dnd.manager().target = null;
                        var item = source.getItem(nodes[0].id);
                        if(item){
                            var keyword = item.data.scriptObj;
                            if(row.id || row.id != ""){ // insert before an existing step/keyword
	                            setTimeout(dojo.hitch(this, function(row,keyword){
									this._addKeyword(row,keyword,false,true);
									this._showSteps();
									this.setParentDirty();		
								},row,keyword),0);
                            }else{ //insert before a "Click to Add... " row
                            setTimeout(dojo.hitch(this, function(keyword){
									this._addKeyword(null,keyword,false,true);
									this._showSteps();
									this.setParentDirty();		
								},keyword),0);
                            }
                        }
	                }
				}
				else if(target.accept[this.id]){ // the steps drop is meant for me
					dojo.dnd.manager().target = null;
					setTimeout(dojo.hitch(this,"_reOrganizeSteps"),0);
				}
            }
        },
		_reOrganizeSteps:function(){
			this.setParentDirty();	
			this._preserveEditedContent();
			var newSteps = [];
			var newProps = [];
			var stepNum = 0;
			for(var i=0;i<this._stepsTableBody.rows.length-1 ; i++){
				stepNum = this._getStepNumForRow(this._stepsTableBody.rows[i]);
				newSteps.push(this._steps[stepNum-1]);
			}					
			this._steps = newSteps;
			this._showSteps();
		},
        _createSplitContainer: function() {
			if (!this.isReadOnly()) {
				this._kwView = new com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView({editor: this});
				this._kwContainer.appendChild(this._kwView.domNode);
				this.stepsDndSource = new dojo.dnd.Source(this._stepsTableBody, {
					accept: [this.id],
					creator: dojo.hitch(this,this._dndCreator),
					copyOnly:true,
					withHandles:true,
					delay:20
				});
			this.stepsDndSource.getSelectedNodes = dojo.hitch(this,"getSelectedNodes");
			dojo.style(this._stepsContainer, "height", "500px");//Make the toolbar always visible
			} else {			
				//if read-only, no need to show keywords
				this._kwContainer.style.display = "none";
				dojo.style(this._stepsContainer, "height", "auto");
			}
			this._editorContainer.setAttribute("tabIndex", -1);
			
        },
		getSelectedNodes: function(){
		// summary: returns a list (an array) of selected nodes
			var t = new dojo.NodeList();
			var e = dojo.dnd._empty;
			for(var i in this.stepsDndSource.selection){
				if(i in e){ continue; }
				t.push(dojo.byId(i));
			}
			t = t.sort(function(a1,a2){
				if(a1.id < a2.id)
					return -1;
				else
					return 1;
			});
			return t;	// Array
		},
		
		_showSteps: function() {
			if (this.isReadOnly()) {
				this.stepBeingEdited = -1;
				this.lastClickedRow = "none";
			}
			dojox.data.dom.removeChildren(this._stepsTableBody);
			dojo.forEach(this.onmousemoveEvent,function(e){
				dojo.disconnect(e);
			});
			if (this.stepsDndSource) {
				this.stepsDndSource.clearItems();
			} else {
				dojox.data.dom.removeChildren(this._stepsTableBody);
			}
			if ( this._steps != null && this._steps.length > 0 ) {
				for ( var i = 0; i < this._steps.length; i++ ) {
					this._steps[i].num = i + 1;
					if(this.stepBeingEdited == i+1)
						this._insertStepRow(null, this._steps[i], true);
					else 
						this._insertStepRow(null, this._steps[i], false);
				}
			}
			if (!this.isReadOnly()) {
				this._appendNewStepLinkRow();
			}
			var step1 = dojo.byId(this.ID_STEP_SUMMARY + 1);
			if(step1)
				step1.parentNode.focus();
		},
		
		updateSteps: function(steps) {
			this._steps = steps ? steps : this._steps;
			for ( var i = 0; i < this._steps.length; i++ ) {
				this._steps[i].num = i + 1;
				var row = this._stepsTableBody.rows[i] ? this._stepsTableBody.rows[i] : null;
				this._insertStepRow(row, this._steps[i], false);
			}
			if(row){
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this._steps[this._getStepNumForRow(row) -1].properties);
			}
		},
		_getEmptyRow: function() {
			var row = document.createElement("tr");
			dojo.addClass(row,"steps-table-row");
			return row;
		},
		
		_getEmptyCell: function(span, align) {
			var cell = document.createElement("td");
			dojo.addClass(cell,"steps-table-cell");
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ) {
				cell.align = align;
			}
			return cell;
		},
		
		_buildDetailRow: function(step,editable) {
			//build details row
			var detailsDiv = document.createElement("div");
			detailsDiv.id = this.ID_DETAIL_EDITOR_DIV + step.num;	
			dojo.addClass(detailsDiv, "step-detail-container");				
			if (step && step.content) {
				if(editable || !this.showCompactView)
					detailsDiv.innerHTML = unescape(step.content);
				else if(!editable && this.showCompactView)
					detailsDiv.innerHTML = unescape(step.summary);
			}
			return detailsDiv;		
		},
		
		_buildExpectedResultDiv: function(step,editable){
			var detailsDiv = document.createElement("div");
			detailsDiv.id = this.ID_EXPECTED_RES_DIV + step.num;	
			dojo.addClass(detailsDiv, "step-detail-container");				
			if (step && step.expectedResult) {
				if (editable || !this.showCompactView) 
					detailsDiv.innerHTML = unescape(step.expectedResult);
				else 
					if (!editable && this.showCompactView) {
						if(!step.expectedResult)
							step.expectedResult = "";
						if(!step.expectedResSummary)
							step.expectedResSummary = this._getSummary(step.expectedResult);
						detailsDiv.innerHTML = unescape(step.expectedResSummary);
					}
			}
			return detailsDiv;
		},
		
		_attachEditor: function(identifier) {
			var id = null;
			var isDetail = true;
			if(this.attachingEditor)
				return;
			var prevEditorExpectedResult = false;
			if(this.editor){
				prevEditorExpectedResult = this.editor.domNode.id.match(this.expectedResult_Summary_ID) || this.editor.domNode.id.match(this.expectedResult_ID);
			}	
			var splitOnEditorId = identifier.split(this.ID_DETAIL_EDITOR_DIV);	
			if(splitOnEditorId.length > 1)
				id = splitOnEditorId[1];
			else{
				var splitOnExpectedId = identifier.split(this.ID_EXPECTED_RES_DIV);
				id = splitOnExpectedId[1];
				isDetail = false;
			}	
			this.attachingEditor = true;
			var heightValue= '';
			var nodeId = (isDetail ? this.ID_DETAIL_EDITOR_DIV : this.ID_EXPECTED_RES_DIV )+ id;
			var attachNode = dojo.byId(nodeId);
			if(!attachNode){
				this.stepBeingEdited  = -1;
				this._changeBGColor();
				this.lastClickedRow = "none";
				return;
			}
			this.stepBeingEdited = parseInt(id,10);
			if(!this.editor){
				if(!this.toolbar || !this.toolbar.domNode){
					//toolbar domnode becomes null when editor cannot be destroyed completely.
					this.toolbar = new dijit.Toolbar();
					dojox.data.dom.removeChildren(this._editorHeader);	
					this._editorHeader.appendChild(this.toolbar.domNode);
				}
				var args = {
					height: '',
					minHeight: '25px',
					focusOnLoad: true,
					parentNodeId: this.ID_SUMMARY_ROW+id,
					parentWidget: this,
					toolbar: this.toolbar
				};
				if(this.save){
					args.save = this.save;
				}
				this.editor = new Editor(args, attachNode);
			}else{
				if(this.editor.domNode.id == identifier){
					this.editor.disabled = false;
					this.editor.srcNodeRef = attachNode;
					this.editor.parentNodeId = this.ID_SUMMARY_ROW+id;
					this.editor.open(attachNode);
					this.attachingEditor = false;
					return;
				}
				this.editor.endEditing(true);
				var prevEditorState = this.editor.getState();
				var prevAttachNode = this.editor.domNode;
				dojo.removeClass(prevAttachNode,"step-detail-container");
				var splitValues = this.editor.domNode.id.split("_");
				var prevIdStr = splitValues[splitValues.length -1];
				prevId = parseInt(prevIdStr,10);
				this.lastClickedRow = this.ID_SUMMARY_ROW +prevIdStr;
				if (this._steps[prevId - 1] && !this.editor.disabled) {
					if (prevEditorExpectedResult) {
						this._steps[prevId - 1].expectedResult = escape(this.editor.getValue());
						this._steps[prevId - 1].expectedResSummary = this._getSummary();
					}
					else {
						this._steps[prevId - 1].content = escape(this.editor.getValue());
						this._steps[prevId - 1].summary = this._getSummary();
					}
					if (prevIdStr != id) {
						var detailsNode = dojo.byId(this.ID_DETAIL_EDITOR_DIV + prevIdStr);
						var detailsDiv = this._buildDetailRow(this._steps[prevId - 1]);
						var expectedResNode = dojo.byId(this.ID_EXPECTED_RES_DIV + prevIdStr);
						var expectedResDiv = this._buildExpectedResultDiv(this._steps[prevId - 1]);
						detailsNode.parentNode.replaceChild(detailsDiv, detailsNode);
						expectedResNode.parentNode.replaceChild(expectedResDiv, expectedResNode);
					}
					else 
						if (!prevEditorExpectedResult) {
							var detailsNode = dojo.byId(this.ID_DETAIL_EDITOR_DIV + prevIdStr);
							var detailsDiv = this._buildDetailRow(this._steps[prevId - 1]);
							detailsNode.parentNode.replaceChild(detailsDiv, detailsNode);
						}
				}
				this.editor.disabled = false;
				this.editor.srcNodeRef = attachNode;
				this.editor.parentNodeId = this.ID_SUMMARY_ROW+id;
				this.editor.open(attachNode);
			}
			var content = isDetail ? (this._steps[parseInt(id, 10) -1].content? unescape(this._steps[parseInt(id, 10) -1].content):"")
							: (this._steps[parseInt(id, 10) -1].expectedResult? unescape(this._steps[parseInt(id, 10) -1].expectedResult):"");
			var row = dojo.byId(this.ID_SUMMARY_ROW+id);
			this._changeBGColor(row);
			if (content == "") 
				setTimeout(dojo.hitch(this, this._updateToolBarState, prevEditorState), 100);//Not calling directly IE is not ready for it.
			else {
				this.editor.replaceValue(content);
				this.attachingEditor = false;
			}
		},
		
		_updateToolBarState: function(state){
			if(state){
				this.editor.setState(state);
			}
			//remove the extra space added at the beginning
			this.editor.execCommand("selectall");
			if(dojo.isFF){
				this.editor.execCommand("delete");
			}else
				this.editor.execCommand("inserthtml","");
			this.attachingEditor = false;
		},
		
		_insertRowinBetween:function(stepNumber,/*boolean*/before,stepType,/*in case of keyword*/keyword){
			var stepNum = parseInt(stepNumber, 10);
			var updatedSteps = [];
			var updatedProperties = [];
			var j = 0;
			for ( var i = 0; i < this._steps.length; i++ ) {
				if ( i != (stepNum - 1) ) {
					this._steps[i].num = j + 1;
					var id = i + 1;
					var typeNode = dojo.byId(this.ID_STEP_TYPE + id);		
					if(typeNode == null)
						typeNode = dojo.byId(this.ID_KW_TYPE + id);	
					if (typeNode.stepType) this._steps[i].elementType = this._getElementTypeByName(typeNode.stepType);
					updatedSteps.push(this._steps[i]);
					j = j + 1;
				}else if(i==stepNum-1) {
					var newstep;
					if(before == true){
						newstep = {num: j + 1};
						this._steps[i].num = j + 2;
					}
					else{
						this._steps[i].num = j + 1;
						newstep = {num: j + 2};
					}
					newstep.elementType = this._getElementTypeByName(stepType);
					newstep.content = "";
					newstep.summary = "";
					newstep.expectedResult = "";
					if(keyword)
						newstep.script = keyword;
					var id= i + 1;
					var typeNode = dojo.byId(this.ID_STEP_TYPE + id);		
					if(typeNode == null)
						typeNode = dojo.byId(this.ID_KW_TYPE + id);	
					if (typeNode.stepType) this._steps[i].elementType = this._getElementTypeByName(typeNode.stepType);
					var	content = this._steps[i].content;
					var expectedResult = this._steps[i].expectedResult;
					var summary = this._steps[i].summary;
					this._steps[i].summary = summary?dojo.trim(summary):"";
					this._steps[i].content = content?dojo.trim(content):"";
					this._steps[i].expectedResult = expectedResult?dojo.trim(expectedResult):"";
					if(before == true){
						updatedSteps.push(newstep);
						j = j + 1;
						updatedSteps.push(this._steps[i]);
					}
					else{
						updatedSteps.push(this._steps[i]);
						j = j + 1;
						updatedSteps.push(newstep);
					}
					j = j + 1;
				}
			}
			this._steps = null;
			this._steps = updatedSteps;
		},
		
		_handleRowInsert:function(currentRow,before){
			// cant destroy the editor which is calling this function
			setTimeout(dojo.hitch(this, this._rowInsertInternal,currentRow,before), 200);
		},
		_rowInsertInternal:function(currentRow,before){
			this._preserveEditedContent();
			var stepNum = this._getStepNumForRow(currentRow);
			stepNum = parseInt(stepNum, 10);
			if(!before)
				before = false;
			this._insertRowinBetween(stepNum,before,"Execution Step");
			if(before)
				this.prevStepNum = stepNum+1;
			else
				this.prevStepNum = stepNum -1;
			try{
				this.stepBeingEdited = -1;
				this.lastClickedRow = "none";
				this._showSteps();
				if(!before)
					stepNum = stepNum+1;
				var descriptionElement = dojo.byId(this.ID_STEP_SUMMARY + stepNum);
				var expectedElement = dojo.byId(this.ID_STEP_SUMMARY_EXP+stepNum);
				if (descriptionElement) {
					dojox.data.dom.removeChildren(descriptionElement);
					var detailsDiv = this._buildDetailRow({num: stepNum},false);
					descriptionElement.appendChild(detailsDiv);
					this._attachEditor(this.ID_DETAIL_EDITOR_DIV+stepNum);
					var expectedDiv = this._buildExpectedResultDiv({num: stepNum},false);
					dojo.addClass(expectedDiv, "cellEditable");
					expectedElement.appendChild(expectedDiv);
				}
			}catch(e){console.error("ESEL: Row Insert failed." + e.message);}
			this.setParentDirty();	
		},
		_handleAddClick: function(e, currentRow) {
			if(e)
				dojo.stopEvent(e);
			var row = null;
			var newRow = false;
			if(currentRow){
				var prevEditorExpectedResult = false;
				if(this.editor){
					prevEditorExpectedResult = this.editor.domNode.id.match(this.expectedResult_Summary_ID) || this.editor.domNode.id.match(this.expectedResult_ID);
				}
				if (prevEditorExpectedResult) 
					row = currentRow.nextSibling;
				else {
					var arr = (currentRow.id).split(this.ID_SUMMARY_ROW);
					var id = arr[1];
					this._attachEditor(this.ID_EXPECTED_RES_DIV+id);
					var detailNode = dojo.byId(this.ID_DETAIL_EDITOR_DIV + id);
					if(detailNode){
						dojo.addClass(detailNode,"cellEditable");
					}
					return;
				}
				if(row.id == "")
					newRow = true;
				if(row.id != ""){
					if(row.isKeyword){
						return;
					}else{
						var arr = (row.id).split(this.ID_SUMMARY_ROW);
						var id = arr[1];
						this._attachEditor(this.ID_DETAIL_EDITOR_DIV+id);
						var expectedNode = dojo.byId(this.ID_EXPECTED_RES_DIV + id);
						if (expectedNode) 
							dojo.addClass(expectedNode, "cellEditable");
					}
				}	
			}	
			if(e){
				newRow = true;
				row = e.currentTarget;					
			}
			if(newRow){
				if(row.add_click_handle)
					this.disconnect(row.add_click_handle);
				if(row.add_enter_handle)
					this.disconnect(row.add_enter_handle);
				this._insertStepRow(row, null, true);
				var expectedNode = dojo.byId(this.ID_EXPECTED_RES_DIV + this._getStepNumForRow(row));
				if (expectedNode) 
					dojo.addClass(expectedNode, "cellEditable");
				this._appendNewStepLinkRow();
				if(this._steps.length ==1)
					this._setColWidths();
			}
			if(this.prevStepNum != -1){
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this._steps[this._getStepNumForRow(row) -1].properties);
			}else{
				this.prevStepNum = this._getStepNumForRow(row) -1;
			}
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]:null;
		},
		
		_handleEditClick: function(e, stepNum, currentRow) {
			//required for multi-select of steps
			if(e && (e.ctrlKey||e.shiftKey))
				return;
			var row = null;
			if(currentRow)
				row = currentRow;
			if(e){
				row = e.currentTarget.parentNode;
			}
			if(this.prevStepNum != -1){
				if(currentRow){
					this.prevStepNum = this._getStepNumForRow(currentRow) -1;
				}else
					this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this._steps[this._getStepNumForRow(row) -1].properties);
			}
			else{
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this._steps[this._getStepNumForRow(row) -1].properties);
			}
			if(this.editor && this.editor.domNode.parentNode.id == e.currentTarget.firstChild.id && !this.editor.disabled)
				return;
			var childIds = e.currentTarget.firstChild.id ? e.currentTarget.firstChild.id.split(this.ID_STEP_SUMMARY_EXP) : [];
			var focusNodeId = childIds.length > 1 ? this.ID_EXPECTED_RES_DIV : this.ID_DETAIL_EDITOR_DIV;  
			this._insertStepRow(row, this._getStepForRow(row), true, focusNodeId);
			if (focusNodeId != this.ID_EXPECTED_RES_DIV) {
				var expectedNode = dojo.byId(this.ID_EXPECTED_RES_DIV + this._getStepNumForRow(row));
				if (expectedNode) 
					dojo.addClass(expectedNode, "cellEditable");
			}else{
				var detailNode = dojo.byId(this.ID_DETAIL_EDITOR_DIV + this._getStepNumForRow(row));
				if(detailNode){
					dojo.addClass(detailNode,"cellEditable");
				}
			}

			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]: null;
		},	
		_changeBGColor: function(row){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var prevRow = document.getElementById(this.lastClickedRow)
				if(prevRow){
					dojo.addClass(prevRow,"steps-table-row");
					dojo.removeClass(prevRow, "selected-row");
				}
				if (this.stepsDndSource) {
					this.stepsDndSource.selectNone();
					if (prevRow) {
						dojo.removeClass(prevRow, "dojoDndItemAnchor");
						dojo.removeClass(prevRow, "dojoDndItemSelected");
					}
				}
			}
			if(row){
				this.lastClickedRow = row.id;
				dojo.addClass(row, "selected-row");
			}else
				this.lastClickedRow = "none";			
		},
		
		updateStepType: function(index){
			if(this.changedStepId){
				this.setParentDirty();	
				var stepNum = this.changedStepId;
				var img = dojo.byId(this.ID_STEP_TYPE+stepNum);
				var step=this._steps[this.changedStepId-1];
				if (index.abrv == "rp") {
					step.elementType = this._getElementTypeByName("Reporting Step");
				}
				else {
					step.elementType = this._getElementTypeByName("Execution Step");
				}	
				
				img.title = step.elementType.displayName;
				img.alt= step.elementType.displayName;
				img.src= ImageCache.getTypeIconURL(step.elementType);
				img.stepType = step.elementType.name;
				this.changedStepId = null;		
			}
		},
		_updatePasteCompareProperty:function(properties){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var pasteComparePropertyFound = false;
				if(this._steps[stepNum - 1].properties){
					if(properties && properties.length >0){
						for(var i=0;i<this._steps[stepNum - 1].properties.length;i++){
							if(this._steps[stepNum - 1].properties[i].propertyType == properties[0]){
								this._steps[stepNum - 1].properties[i].propertyName = properties[1];
								this._steps[stepNum - 1].properties[i].propertyValue = properties[2];
								pasteComparePropertyFound = true;
								break;
							}
						}
					}
				}
				else
					this._steps[stepNum - 1].properties = [];
				if(properties && !pasteComparePropertyFound){
					this._steps[stepNum - 1].properties.push({
						propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]
						});							
				}
				this._updateProperties(stepNum);
			}
		},		
		
		_updateCommentProperty:function(properties,noUpdateCommmentArea){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var commentPropertyFound = false;
				if(this._steps[stepNum - 1].properties){
					if(properties && properties.length >0){
						for(var i=0;i<this._steps[stepNum - 1].properties.length;i++){
							if(this._steps[stepNum - 1].properties[i].propertyType == properties[0]){
								this._steps[stepNum - 1].properties[i].propertyName = properties[1];
								this._steps[stepNum - 1].properties[i].propertyValue = properties[2];
								if(properties[2] == "")
									this._steps[stepNum -1].properties.splice(i,1);
								this._steps[stepNum - 1].comments = {propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]};
								commentPropertyFound = true;
								break;
							}
						}
					}
				}
				else
					this._steps[stepNum - 1].properties = [];
				if(properties && !commentPropertyFound && properties[2] != ""){
					this._steps[stepNum - 1].properties.push({
						propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]
						});	
					this._steps[stepNum - 1].comments = {propertyType:properties[0],propertyName:properties[1],propertyValue:properties[2]};						
				}
				this._updateProperties(stepNum);
				if (!noUpdateCommmentArea && properties) {
					var commentArea = document.getElementById(this.ID_COMMENT_COL_AREA + stepNum);
					if(commentArea)
						commentArea.value = properties[2];
				}
			}
		},
		
		_updateAttachmentProperty:function(properties,removedAttachments){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var stepProperties = this._steps[stepNum - 1].properties;
				var newProperties = [];
				if(stepProperties){
					for(var i=0;i<stepProperties.length;i++){
						if(stepProperties[i].propertyType != ATTACHMENT_VIEW_TYPE){
							newProperties.push(stepProperties[i]);
						}
					}
				}
				if(properties && properties.length > 0){
					for(var j=0;j<properties.length;j=j+3){
						newProperties.push({propertyType:properties[j],propertyName:properties[j+1],propertyValue:properties[j+2]
						});
					}
				}
				this._steps[stepNum - 1].properties = newProperties;
				if(!this.removedAttachments)
					this.removedAttachments = new Array();
				this.removedAttachments[stepNum - 1] = removedAttachments;
				this._updateProperties(stepNum);
			}		
		},

		_updateProperties:function(stepNum){
			this.setParentDirty();	
			this._createCurrentProperties(this._steps[stepNum - 1].properties);
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[stepNum - 1]:null;
			var attachCell = dojo.byId(this.ID_ATTACH_CELL+stepNum);
			var commentCell = dojo.byId(this.ID_COMMENT_CELL+stepNum);
			var compareCell = dojo.byId(this.ID_COMPARE_CELL+stepNum);
			var propshtml = this._createPropertiesHtml(stepNum,this.currentProperties);
			if(attachCell)
				attachCell.parentNode.replaceChild(propshtml[0],attachCell);
			if(commentCell)
				commentCell.parentNode.replaceChild(propshtml[1],commentCell);
			if(compareCell)
				compareCell.parentNode.replaceChild(propshtml[2],compareCell);
		},
		
		_getProperties:function(){
			return [this.currentProperties,this.currentRemovedAttachments];
		},
		
		_appendNewStepLinkRow: function() {
			var row = this._getEmptyRow();
			var icon = this._getEmptyCell();
			var image = document.createElement('img');
			image.src = dojo.moduleUrl("com.ibm.asq.common.web", "ui/internal/images/icons/elcl16/add.gif");
			icon.appendChild(image);
			row.appendChild(icon);
			var cell = this._getEmptyCell(10);
			var anchor = document.createElement('a');
			anchor.href = "#";
			anchor.appendChild(document.createTextNode(Constants.getMessage("labelClickToAdd")));	
			cell.style.color = "#1E9494";
			anchor.setAttribute("tabIndex", 0);
			cell.appendChild(anchor);
			row.appendChild(cell);
			this._stepsTableBody.appendChild(row);
			if (!this.isReadOnly()) {
				row.add_click_handle = this.connect(row, "onclick", "_handleAddClick");
				row.add_enter_handle = this.connect(row, "onkeypress", "_keyPressHandler");
			}
		},
		_keyPressHandler:function(e){
			if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE) {
                //perform the open new section dialog on ENTER pressed 
                this._handleAddClick(e);
            }
		},
	    _dndCreator:function(row,hint){
			if(row.id){
				var lastIndex = row.id.lastIndexOf("_");
				var rowNumber = row.id.substr(lastIndex + 1);
				var rowId = row.id.substr(0,lastIndex+1);
	            if(hint == "avatar"){
					this._preserveEditedContent();
					if(!dojo.isIE)
						document.body.style.cursor = "not-allowed";
					var rowNum = parseInt(rowNumber);
					var textDiv = document.createElement("div");
					textDiv.innerHTML = rowNumber + " "+unescape(this._steps[rowNum - 1].summary);
					return {node: textDiv, data: row, type: [rowId]};
	            }
	           return {node: row, data: row, type: [rowId]};				
			}
			var newRow = document.createElement("tr");	
            return {node: newRow, data: null, type: []};
        },

		_isRowEditable: function(row) {
			var stepNum = this._getStepNumForRow(row);
			var typeElement = document.getElementById(this.ID_STEP_TYPE + stepNum);
			var descElement = document.getElementById(this.ID_DETAIL_EDITOR_DIV + stepNum);
			var expectedResElement = document.getElementById(this.ID_EXPECTED_RES_DIV + stepNum);
			return ( 
				typeElement != null && descElement != null && expectedResElement != null
				(descElement.tagName.toUpperCase() == "DIV")
			);
		},				
		_createPropertiesHtml: function(stepNum,properties){
			var attachCell = this._getEmptyCell();
			attachCell.id = this.ID_ATTACH_CELL+stepNum;
			attachCell.align = "right"; 
			var attachmentsHtml = document.createElement("span");
			var attachmentsHtmlContent = attachmentsHtml.appendChild(document.createElement("table"));
			
			var commentCell = this._getEmptyCell();
			commentCell.id = this.ID_COMMENT_CELL+stepNum;
			commentCell.align = "right";
			dojo.addClass(commentCell,"commentProp");
			var commentsHtmlContent = document.createElement("span");

			var compareCell = this._getEmptyCell();
			compareCell.id = this.ID_COMPARE_CELL+stepNum;
			compareCell.align = "right";
			var compareHtmlContent = document.createElement("span");
			
			var attachmentFound = false;
			var commentFound = false;
			var compareFound = false;
			var attachmentCount= 0;
			
			if(properties) {
				for(var i=0;i<properties.length;i++){
					switch(properties[i].propertyType){
						case ATTACHMENT_VIEW_TYPE:
							if(attachmentFound == false){
								var attachImg = document.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachCell.appendChild(attachImg);
								attachImg.setAttribute("tabIndex", 0);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow();
							var attachmentsHtmlContentCell = this._getEmptyCell();
							var attachmentsAnchor = document.createElement("a");
							attachmentsAnchor.target = "_blank";
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							attachmentsAnchor.appendChild(document.createTextNode(attachmentsText));
							attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							dojo.style(attachmentsAnchor,"fontSize","0.7em");
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;
							
						case COMMENT_VIEW_TYPE:
							if(stepNum && this._steps[stepNum - 1])
								this._steps[stepNum - 1].comments = properties[i];
							commentFound = true;
							dojox.data.dom.removeChildren(commentsHtmlContent);
							commentsHtmlContent.appendChild(document.createTextNode(properties[i].propertyValue));
							commentImg = document.createElement("img");
							commentImg.alt= Constants.getMessage("labelComment");
							commentImg.src = ImageCache.COMMENT;
							commentImg.className = "type-image";
							commentImg.setAttribute("tabIndex", 0);
							commentCell.appendChild(commentImg);
							if(this.showCommentsCol)
								dojo.style(commentCell,'display','none');
							break;
						
						case COMPARE_VIEW_TYPE:
							compareFound = true;
							dojox.data.dom.removeChildren(compareHtmlContent);
							var value = properties[i].propertyValue.replace(/&colon;/g, ":");
							compareHtmlContent.appendChild(document.createTextNode(value));
							compareImg = document.createElement("img");
							compareImg.alt= Constants.getMessage("labelComment");
							compareImg.src = ImageCache.COMPARE;
							compareImg.className = "type-image";
							compareImg.setAttribute("tabIndex", 0);
							compareCell.appendChild(compareImg);
							break;
						default:
							//do Nothing
					}
				}	
			}
			if(attachmentCount>0){
				var tooltip = null;
				var _attachmentTooltipSpan = document.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = document.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
				this._tooltips.push(tooltip);
			}
			if(commentFound ===true){
				var tooltip = null;
				var _commentTooltipSpan = document.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);
				this._tooltips.push(tooltip);				
			}			
			if(compareFound ===true){
				var tooltip = null;
				var _compareTooltipSpan = document.createElement("span");
				compareCell.appendChild(_compareTooltipSpan);
				tooltip = new HoverPopup({around: [compareImg],html:compareHtmlContent.innerHTML}, _compareTooltipSpan);
				this._tooltips.push(tooltip);				
			}			
			return [attachCell,commentCell,compareCell];
		},			
					
		_insertStepRow: function(targetRow, step, editable, focusNodeId) {
			editable = editable != null && editable == true ? true : false ;
			if(step == null){
				this.setParentDirty();	
			}
			var stepNum = step != null ? step.num : (targetRow == null ? this._steps.length + 1 : this._getStepNumForRow(targetRow));
			if (targetRow == null) {
				//build empty target row
				targetRow = this._getEmptyRow();
				targetRow.id = this.ID_SUMMARY_ROW + stepNum;
				if (this.stepsDndSource) {
				    this.stepsDndSource.insertNodes(false,[targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			} else if (step == null) {
				//new step - (add clicked)	
				step = {num: stepNum};
				this._steps.push(step);	
				targetRow.id = this.ID_SUMMARY_ROW + stepNum;
				if (this.stepsDndSource) {
			    	this.stepsDndSource.insertNodes(false,[targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			}
			if(step.elementType && step.elementType.name == "Keyword"){
				var keywordId = null;
				var keywordExternalId = null;
				for(var i=0;i<this._steps[stepNum-1].properties.length;i++){
					if(this._steps[stepNum-1].properties[i].propertyType=="keyword"){
						if(this._steps[stepNum-1].properties[i].propertyName == "keywordExternalId")
							keywordExternalId = this._steps[stepNum-1].properties[i].propertyValue;
						else if(this._steps[stepNum-1].properties[i].propertyName == "keywordId")
							keywordId = this._steps[stepNum-1].properties[i].propertyValue;
						break;
					}
				}
				if(!keywordId && !keywordExternalId)
					return;
				if (keywordId != null) {
					var keyword = this.scriptObjects[keywordId];
					if (keyword) {
						this._addKeyword(targetRow, keyword, true);
						return;
					}
				}
				var self = this;
				var callbackObj = {
					success: function(keywords){
						self._addKeyword(targetRow, keywords[0], true);
					},
					failure: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				if (keywordId != null) {
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						id: keywordId,
						includeArchived: true
					});
				}
				else if (keywordExternalId != null) {
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						externalId: keywordExternalId,
						includeArchived: true
					});
				}
				return;
			}
			dojox.data.dom.removeChildren(targetRow);
			var numCell = this._getEmptyCell();
			numCell.align = "center";
			numCell.appendChild(document.createTextNode(stepNum));
			dojo.addClass(numCell,"dojoDndHandle");
			targetRow.appendChild(numCell);
			var typeCell = this._getEmptyCell();
			typeCell.align = "left";
			typeCell.vAlign = "center";
			var typeElement = null;
			if ( editable ) {
				//create & populate a select element
				typeElement = document.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + stepNum;
				if(this._elementTypes && step.elementType == null){
					step.elementType = this._getElementTypeByName("Execution Step");
				}else{
					step.elementType = this._getElementTypeByName(step.elementType.name);
				}
				typeElement.title = step.elementType.displayName;
				typeElement.alt= step.elementType.displayName;
				typeElement.src= ImageCache.getTypeIconURL((step.elementType != null ? step.elementType : null));
				typeElement.className = "type-image";
				typeElement.stepType = step.elementType.name;
			} else {
				step.elementType = this._getElementTypeByName(step.elementType.name);
				typeElement = document.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + step.num;
				typeElement.title = step.elementType.displayName;
				typeElement.alt= step.elementType.displayName;
				typeElement.src= ImageCache.getTypeIconURL(step.elementType);
				typeElement.className = "type-image";
				typeElement.stepType = step.elementType.name;
			}
			typeElement.align = "right";
			typeCell.appendChild(typeElement);
			dojo.removeClass(typeCell,"steps-table-cell");
			dojo.addClass(typeCell,"steps-table-cell-image");
			targetRow.appendChild(typeCell);
			var dropdownCell = this._getEmptyCell();
			var dropdown = document.createElement("img");
			dropdown.id = this.ID_TYPE_DROPDOWN + stepNum;
			dropdown.src = ImageCache.DROPDOWN_ARROW;
			dropdown.align = "left";
			dropdown.setAttribute("tabIndex", 0);
			dropdownCell.appendChild(dropdown);
			dojo.removeClass(dropdownCell,"steps-table-cell");
			dojo.addClass(dropdownCell,"steps-table-cell-image");
			targetRow.appendChild(dropdownCell);
            if (!this.isReadOnly()) {
				this._createContextMenu(dropdown.id,stepNum);//Create step change context menu for the image only
			}
			//step name / description cell
			var descriptionCell = this._getEmptyCell();
			dojo.addClass(descriptionCell,"dojoDndHandle");
			dojo.addClass(descriptionCell,"steps-table-cell-detail");
			var descriptionElement = null;
			descriptionElement = document.createElement('div');
			descriptionElement.id = this.ID_STEP_SUMMARY + stepNum;
			this.onmousemoveEvent.push(dojo.connect(descriptionElement, "onmousemove", this, function(e){
				dojo.stopEvent(e);
			}));
			if(this.descMaxWidth)
				descriptionElement.style.maxWidth = this.descMaxWidth+"px";
			var detailsDiv = this._buildDetailRow(step,editable);
			descriptionElement.appendChild(detailsDiv);	
			descriptionCell.appendChild(descriptionElement);
			targetRow.appendChild(descriptionCell);
			if ( editable && (focusNodeId == this.ID_DETAIL_EDITOR_DIV || !focusNodeId)) {
				this._attachEditor(this.ID_DETAIL_EDITOR_DIV+stepNum);
			}
			
			//Empty cell for resizer
			var emptyCell = this._getEmptyCell();
			targetRow.appendChild(emptyCell);
			
			//expected cell
			var expectedResultCell = this._getEmptyCell();
			dojo.addClass(expectedResultCell,"dojoDndHandle");
			dojo.addClass(expectedResultCell,"steps-table-cell-detail");
			var expectedResultElement = null;
			expectedResultElement = document.createElement('div');
			expectedResultElement.id = this.ID_STEP_SUMMARY_EXP + stepNum;
			this.onmousemoveEvent.push(dojo.connect(expectedResultElement, "onmousemove", this, function(e){
				dojo.stopEvent(e);
			}));
			if (this.expMaxWidth) {
				expectedResultElement.style.maxWidth = this.expMaxWidth + "px";
			}
			var expectedResultDiv = this._buildExpectedResultDiv(step,editable);
			expectedResultElement.appendChild(expectedResultDiv);	
			expectedResultCell.appendChild(expectedResultElement);
			targetRow.appendChild(expectedResultCell);
			if ( editable && focusNodeId == this.ID_EXPECTED_RES_DIV) {
				this._attachEditor(this.ID_EXPECTED_RES_DIV+stepNum);
			}
			var properties= null;
			this._createCurrentProperties(this._steps[stepNum - 1].properties);
			if(this.currentProperties.length != 0)
				properties = this.currentProperties;
			var propshtml = this._createPropertiesHtml(stepNum,properties);
			
			//comment cell
			var commentColCell = this._getEmptyCell();
			var commentArea = document.createElement("textarea");
			commentArea.id = this.ID_COMMENT_COL_AREA+stepNum;
			commentArea.value = this._steps[stepNum - 1].comments?this._steps[stepNum - 1].comments.propertyValue:"";
			this.connect(commentArea,'onblur',function(e){
				this.lastClickedRow = this.ID_SUMMARY_ROW +stepNum;
				this._updateCommentProperty([COMMENT_VIEW_TYPE,"comment",e.target.value],true);
			});
			this.connect(commentArea,'onclick',function(e){
				e.currentTarget.focus();
				dojo.stopEvent(e);
			});
			commentColCell.appendChild(commentArea);
			commentColCell.align = "right";
			dojo.style(commentColCell,"width","15%");
			targetRow.appendChild(commentColCell);
			commentColCell.id = this.ID_COMMENT_COL_CELL+stepNum;
			dojo.addClass(commentColCell,"commentArea");
			if(!this.showCommentsCol)
				dojo.style(commentColCell,'display','none');
			
			//Properties
			targetRow.appendChild(propshtml[0]);
			targetRow.appendChild(propshtml[1]);
			targetRow.appendChild(propshtml[2]);
			
			var actionCell = this._getEmptyCell();
			actionCell.align = "right";
			var dropdownCell2 = this._getEmptyCell();
			targetRow.appendChild(dropdownCell2);		
			targetRow.appendChild(actionCell);
			//show remove action button, if not in read-only mode
			if (!this.isReadOnly()){
				var dropdown2 = document.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + step.num;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				dojo.removeClass(dropdownCell2,"steps-table-cell");
				dojo.addClass(dropdownCell2,"steps-table-cell-image");
				var menu = this._createInsertContextMenu(dropdown2.id,targetRow.id);
				dropdown2.insertMenu = menu; 
				dropdown2.setAttribute("tabIndex", 0);
				this.connect(dropdown2, "onclick", function(evt){evt.currentTarget.insertMenu._openMyself(evt);});
				this.connect(dropdown2, "onkeypress", function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.DOWN_ARROW)
						evt.currentTarget.insertMenu._openMyself(evt);
					});
				var removeButton = document.createElement("img");
				removeButton.src = ImageCache.REMOVE_DISABLED;
				removeButton.alt = Constants.getMessage("labelRemoveStep");
				removeButton.title = Constants.getMessage("labelRemoveStep");
				removeButton.setAttribute("tabIndex", 0);
				this.connect(removeButton, "onclick", "onStepRemove");
				this.connect(removeButton, "onkeypress", function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.SPACE){
						this.onStepRemove(evt);
					}
				});
				this.connect(removeButton, "onmouseover", "_onRemoveMouseOver");
				this.connect(removeButton, "onfocus", "_onRemoveMouseOver");
				this.connect(removeButton, "onmouseout",  "_onRemoveMouseOut");
				this.connect(removeButton, "onblur",  "_onRemoveMouseOut");		
				actionCell.appendChild(removeButton);				
			}		
			if (!this.isReadOnly()) {
				descriptionCell.setAttribute("tabIndex", 0);
				descriptionCell.edit_click_handle = this.connect(descriptionCell, "onclick", "_handleEditClick");
				descriptionCell.edit_enter_handle = this.connect(descriptionCell, "onkeypress", 
					function(e){
						if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE)
							this._handleEditClick(e);
					});
				expectedResultCell.setAttribute("tabIndex", 0);
				expectedResultCell.edit_click_handle = this.connect(expectedResultCell, "onclick", "_handleEditClick");
				expectedResultCell.edit_enter_handle = this.connect(expectedResultCell, "onkeypress", 
					function(e){
						if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE)
							this._handleEditClick(e);
					});	
			}
		},
		
		_insertKeyword:function(targetRow,keywordName,script,stepNum){
			var numCell = this._getEmptyCell();
			numCell.align = "center";
			numCell.appendChild(document.createTextNode(stepNum));
			targetRow.appendChild(numCell);
			targetRow.isKeyword = true;
			//step type cell
			var typeCell = this._getEmptyCell();
			typeCell.align = "left";
			typeCell.vAlign = "top";
			var typeElement = null;
			typeElement = document.createElement("img");
			typeElement.id = this.ID_KW_TYPE + stepNum;
			typeElement.title = Constants.getMessage("labelKeyword");
			typeElement.alt= Constants.getMessage("labelKeyword");
			typeElement.src= ImageCache.getTypeIconURL(this._getElementTypeByName("Keyword"));
			typeElement.stepType = "Keyword";
			typeElement.className = "type-image";			
			typeCell.appendChild(typeElement);			
			targetRow.appendChild(typeCell);
			var dropdownCell = this._getEmptyCell();
			var dropdown = document.createElement("text");
			dropdown.id = this.ID_TYPE_DROPDOWN + stepNum;
			dropdown.align = "left";
			dropdownCell.appendChild(dropdown);
			dojo.removeClass(dropdownCell,"steps-table-cell");
			dojo.addClass(dropdownCell,"steps-table-cell-image");
			targetRow.appendChild(dropdownCell);
			//step name / description cell
			var descriptionCell = this._getEmptyCell(6);	
			var descriptionElement = document.createElement("table");
			var descriptionElementBody = document.createElement("tbody");
			descriptionElement.width = "100%";
			descriptionElement.style.borderSpacing = 0;
			var descriptionRow = this._getEmptyRow();
			var descriptionInnerCell = this._getEmptyCell(8);
			var detailsDiv = document.createElement('div');
			detailsDiv.innerHTML = keywordName;
			descriptionInnerCell.appendChild(detailsDiv);
			descriptionRow.appendChild(descriptionInnerCell);
			descriptionElementBody.appendChild(descriptionRow);
			descriptionElement.appendChild(descriptionElementBody);
			descriptionCell.appendChild(descriptionElement);
			targetRow.appendChild(descriptionCell); 
			descriptionCell.setAttribute("tabIndex", 0);			
			//script statements
			if(script && script.elements && !this.showCompactView){	
				for(var i=0;i<script.elements.length;i++){
					var keywordStepsRow = this._getEmptyRow();
					var typeCell2 = this._getEmptyCell();
					dojo.style(typeCell2,"width","16px");
					typeElement = document.createElement("img");
					typeElement.id = this.ID_KW_TYPE + stepNum;
					typeElement.title = Constants.getMessage("labelKeyword");
					typeElement.alt= Constants.getMessage("labelKeyword");
					typeElement.src= ImageCache.getTypeIconURL(this._getElementTypeByName(script.elements[i].elementType.name));
					typeElement.className = "type-image";
					typeElement.stepType = script.elements[i].elementType.name;
					typeCell2.appendChild(typeElement);
					keywordStepsRow.appendChild(typeCell2);
					var keywordCell = this._getEmptyCell();
					var keywordSteps = document.createElement('div');
					keywordSteps.innerHTML = script.elements[i].content ? unescape(script.elements[i].content) : "";
					keywordCell.appendChild(keywordSteps);
					keywordCell.id = this.ID_KW_SUMMARY_CELL + this.keywordStepsCounter;
					keywordSteps.id = this.ID_KW_SUMMARY + this.keywordStepsCounter;
					if (this.descMaxWidth) {
						keywordCell.width = this.descMaxWidth - 42 + "px";
						keywordSteps.style.maxWidth = (this.descMaxWidth-52)+"px";
					}
					else 
						this._setColWidths();
					keywordSteps.style.overflow = 'auto';
					dojo.addClass(keywordCell,"steps-table-cell-detail");
					keywordStepsRow.appendChild(keywordCell);
					var keywordExpCell = this._getEmptyCell();
					var keywordExpSteps = document.createElement('div');
					keywordExpSteps.innerHTML = script.elements[i].expectedResult ? unescape(script.elements[i].expectedResult) : "";
					keywordExpCell.appendChild(keywordExpSteps);
					keywordExpCell.id = this.ID_KW_SUMMARY_EXP_CELL + this.keywordStepsCounter;
					keywordExpSteps.id = this.ID_KW_SUMMARY_EXP + this.keywordStepsCounter;
					if (this.expMaxWidth) {
						keywordExpCell.width = this.expMaxWidth + "px";
						keywordExpSteps.style.maxWidth = (this.expMaxWidth)+"px";
					}
					else 
						keywordExpCell.width = "45%";
					keywordExpSteps.style.overflow = 'auto';
					keywordStepsRow.appendChild(keywordExpCell);
					var properties = script.elements[i].properties;
					var propshtml = this._createPropertiesHtml(stepNum+"_"+i,properties);
					keywordStepsRow.appendChild(propshtml[0]);
					keywordStepsRow.appendChild(propshtml[1]);
					keywordStepsRow.appendChild(propshtml[2]);
					descriptionElementBody.appendChild(keywordStepsRow);
					this.keywordStepsCounter++;
				}
			}	
			//remove button
			var actionCell = this._getEmptyCell();
			actionCell.align = "right";
			var dropdownCell2 = this._getEmptyCell();
			targetRow.appendChild(dropdownCell2);
			targetRow.appendChild(actionCell);
			if (!this.isReadOnly()) {
				var dropdown2 = document.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + stepNum;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				dojo.removeClass(dropdownCell2,"steps-table-cell");
				dojo.addClass(dropdownCell2,"steps-table-cell-image");
				var menu = this._createInsertContextMenu(dropdown2.id,targetRow.id);
				dropdown2.insertMenu = menu; 
				dropdown2.setAttribute("tabIndex", 0);
				this.connect(dropdown2, "onclick", function(evt){evt.currentTarget.insertMenu._openMyself(evt);});
				this.connect(dropdown2, "onkeypress", function(evt){
					if (evt.keyCode == dojo.keys.DOWN_ARROW)
						evt.currentTarget.insertMenu._openMyself(evt);
					});
				var removeButton = document.createElement("img");
				removeButton.src = ImageCache.REMOVE_DISABLED;
				removeButton.alt = Constants.getMessage("labelRemoveStep");
				removeButton.title = Constants.getMessage("labelRemoveStep");
				removeButton.setAttribute("tabIndex", 0);
				this.connect(removeButton, "onclick", "onStepRemove");
				this.connect(removeButton, "onkeypress", function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.SPACE)
						this.onStepRemove(evt);
					});
				this.connect(removeButton, "onmouseover", "_onRemoveMouseOver");
				this.connect(removeButton, "onfocus", "_onRemoveMouseOver");
				this.connect(removeButton, "onmouseout", "_onRemoveMouseOut");
				this.connect(removeButton, "onblur", "_onRemoveMouseOut");
				actionCell.appendChild(removeButton);
			}
		},
		
		_addKeyword: function(targetRow,keyword,replaceCurrent, updateView) {
			var stepNum =0;
			this._preserveEditedContent();
			if (targetRow == null) {
				stepNum = this._steps.length + 1;
				var step = {num: stepNum};
				this._steps.push(step);				
				//build empty target row
				targetRow = this._getEmptyRow();
				targetRow.id = this.ID_SUMMARY_ROW + stepNum;
				if (this.stepsDndSource) {
					this.stepsDndSource.insertNodes(false, [targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			}
			else{
				stepNum = this._getStepNumForRow(targetRow);
				if(replaceCurrent == false){
					this._insertRowinBetween(stepNum,true,"Keyword",keyword.id);
                    if(!this._steps[stepNum-1].properties)
					    this._steps[stepNum-1].properties = [];
					this._steps[stepNum-1].properties.push({
						propertyType: "keyword",
						propertyName: "keywordId",
						propertyValue: keyword.id
					});
					if(!updateView)
						this._showSteps();
					return;
				}
			}
            if(!this._steps[stepNum-1].properties)
					    this._steps[stepNum-1].properties = [];
					this._steps[stepNum-1].properties.push({
						propertyType: "keyword",
						propertyName: "keywordId",
						propertyValue: keyword.id
					});			
			dojox.data.dom.removeChildren(targetRow);
			this._steps[stepNum-1].content=escape(keyword.name);
			this._steps[stepNum-1].expectedResult=escape(keyword.name);
			this._steps[stepNum-1].summary=escape(keyword.name);
			this._steps[stepNum-1].elementType = this._getElementTypeByName("Keyword");
			this._steps[stepNum-1].script=keyword.defaultScript?keyword.defaultScript.id+'':keyword.manualScript.id+'';
			this.scriptObjects[keyword.id] = keyword;
			var script = null;
			if(!keyword.defaultScript || keyword.defaultScript.itemId == keyword.manualScript.itemId)
				script = keyword.manualScript;
			this._insertKeyword(targetRow,keyword.name,script,stepNum);	
		},
		
		_onRemoveMouseOver: function(e)	{
			e.target.src = ImageCache.REMOVE_ENABLED;
		},
		
		_onRemoveMouseOut: function(e) {
			e.target.src = ImageCache.REMOVE_DISABLED;
		},	
				
		_getStepByNum: function(num) {
			for (var i = 0; i < this._steps.length; i++) {
				if (this._steps[i].num == num) {
					return this._steps[i];	
				}
			}
			return null;
		},
		
		_getStepNumForRow: function(row) {
			var rowIndex = row.sectionRowIndex;
			if ( row.id && dojo.trim(row.id).length > 0 ) {
				return row.id.substr(row.id.lastIndexOf("_") + 1);
			} else 
				return (rowIndex+1);
		},		
		
		_getStepForRow: function(row) {
			return this._steps[this._getStepNumForRow(row) - 1];			
		},		
		
		getElements: function() {
			return this._steps;
		},			
		
		_initElementTypes: function() {
			var handler = new ServiceResponseHandler(this, "_setElementTypes", "_error");
			RegistryClient.getAllExecutionElementTypes(handler);			
		},
		
		_getElementTypeByName: function(typeName) {
			for ( var i = 0; i < this._elementTypes.length; i++ ) {
				if ( this._elementTypes[i].name == typeName ) {
					return this._elementTypes[i];
				}
			}
			return null;
		},	
		
		_setElementTypes: function(allTypes) {
			this._elementTypes = allTypes;
			for(var i=0;i<this._elementTypes.length;i++){
				if(this._elementTypes[i].name == "Execution Step")
					this._elementTypes[i].displayName = Constants.getMessage("labelExecutionStep");
				else if(this._elementTypes[i].name == "Reporting Step")
					this._elementTypes[i].displayName = Constants.getMessage("labelReportingStep");
			}
			this._showSteps();
			if (!this.isReadOnly()) {
				this._resizeHandle = new ResizeHandle({
					targetContainer: this.desc_col,
					resizeAxis: 'x',
					minHeight: 0,
					minWidth:150,
					activeResize: true,
					activeResizeClass: "stepsEditorResizeHandleClone",
					onResize: dojo.hitch(this, function(){
						this._setColWidths();
					})
				});
				this._resizeHandle.placeAt(this.resizer);
				this._resizeHandle.resizeHandle.className = "stepsResizeHandle";
			}
			this._setColWidths();
			this.connect(window,"onresize","_setColWidths");
		},
		_setColWidths:function(){
			var width = this.desc_col.offsetWidth;
			var width2 = this.exp_col.offsetWidth;
			if(!dojo.isIE)
				this.exp_col.style.width = "auto";
			else
				this.exp_col.style.width = "";
			this.descMaxWidth = width;
			this.expMaxWidth = width2;
			for(var j=1;j<this._steps.length+1;j++){
				var descDiv = document.getElementById(this.ID_STEP_SUMMARY+j);
				if(descDiv)
					descDiv.style.maxWidth = width+"px";
				var expDiv = document.getElementById(this.ID_STEP_SUMMARY_EXP+j);
				if (expDiv) {
					expDiv.style.maxWidth = width2 + "px";
				}
			}
			for (var k = 0; k < this.keywordStepsCounter; k++) {
				var keywordStepDesc = document.getElementById(this.ID_KW_SUMMARY + k);
				if(keywordStepDesc)
					keywordStepDesc.style.maxWidth = (width-52)+"px";
				var keywordStepCell = document.getElementById(this.ID_KW_SUMMARY_CELL+k);
				if(keywordStepCell)
					keywordStepCell.style.width = (width-42)+"px";
				var keywordStepExp = document.getElementById(this.ID_KW_SUMMARY_EXP + k);
				if(keywordStepExp)
					keywordStepExp.style.maxWidth = (width2)+"px";
				var keywordExpCell = document.getElementById(this.ID_KW_SUMMARY_EXP_CELL+k);
				if(keywordExpCell)
					keywordExpCell.style.width = width2+"px";
			}
		},
		validateElements: function() {
			this._preserveEditedContent();
			for ( var i = this._steps.length; i >0 ; i-- ) {
				if ( !this.onStepSave(this._stepsTableBody.rows[i-1]) ) {
					return false;
				}
			}
			return true;
		},			
			
		onCancel: function(){
			if(this.parentCallBack)
				this.parentCallBack.setHeaderStatus(Constants.getMessage("msgChangesNotSaved"), Constants.HEADER_STATUS_WARNING);
			else
				alert(Constants.getMessage("msgChangesNotSaved"));
		},
		
		handleRowDelete: function(id, row){
			var currentEId = id.split(this.ID_EXPECTED_RES_DIV);
			if(currentEId.length > 1){
				currentEId = id.split(this.ID_EXPECTED_RES_DIV);
				var stepNum = currentEId[currentEId.length -1];
				this._preserveEditedContent();
				this.setParentDirty();
				this._attachEditor(this.ID_DETAIL_EDITOR_DIV+stepNum);
				var expectedNode = dojo.byId(id);
				if (expectedNode) 
					dojo.addClass(expectedNode, "cellEditable");
				return;
			}
			var prevRow = row.previousSibling;
			if(!prevRow)
				return;
			currentEId = id.split(this.ID_DETAIL_EDITOR_DIV);
			var currId = currentEId[currentEId.length -1];
			var prevId = parseInt(currId, 10);
			if(prevRow && this.prevStepNum != -1){
				this._preserveEditedContent();
				this.setParentDirty();
				this.prevStepNum = this._getStepNumForRow(prevRow);
				this._attachEditor(this.ID_EXPECTED_RES_DIV+this.prevStepNum);
				this._createCurrentProperties(this._steps[this.prevStepNum -1].properties);
				var detailNode = dojo.byId(this.ID_DETAIL_EDITOR_DIV + this.prevStepNum);
				if(detailNode){
					dojo.addClass(detailNode,"cellEditable");
				}
				var curretDetailNode = dojo.byId(id);
				if(curretDetailNode){
					dojo.removeClass(curretDetailNode,"cellEditable");
				}
				var curretExpNode = dojo.byId(this.ID_EXPECTED_RES_DIV+prevId);
				if(curretExpNode){
					dojo.removeClass(curretExpNode,"cellEditable");
				}
			}
		},
		
		onStepRemove: function(e) {
			var row = e.currentTarget.parentNode.parentNode;
			var stepNum = this._getStepNumForRow(row);
			this._deleteAction(stepNum);
			return false;
		},
		_deleteAction: function(stepNum) {	
			this.setParentDirty();	
			var updatedSteps = [];
			var updatedProperties = [];
			var newRemovedAttachments = [];
			var j = 0;
			this._preserveEditedContent();
			for ( var i = 0; i < this._steps.length; i++ ) {
				if ( i != (stepNum - 1) ) {
					this._steps[i].num = i + 1;
					updatedSteps.push(this._steps[i]);
					newRemovedAttachments = this.removedAttachments? this.removedAttachments[i]:null;
					j=j+1;
				}else{
					this.prevStepNum = this.ID_STEP_SUMMARY+i;//VAIBHAV ===ID_STEP_SUMMARY_EXP
					this.lastClickedRow = this.ID_STEP_SUMMARY+i;
				}
			} 
			this._steps = null;
			this._steps = updatedSteps;
			this.removedAttachments = newRemovedAttachments;
			this._showSteps();
		},
		_preserveEditedContent: function(continueEditing){
			if(this.stepBeingEdited != -1 && this.editor){
				if(!continueEditing)
					this.editor.endEditing(true);
				if (!this.editor.domNode.id.match(this.expectedResult_ID) && !this.editor.domNode.id.match(this.expectedResult_Summary_ID)) {
					this._steps[this.stepBeingEdited - 1].content = escape(this.editor.getValue());
					this._steps[this.stepBeingEdited - 1].summary = this._getSummary();
				}else {
					this._steps[this.stepBeingEdited - 1].expectedResult = escape(this.editor.getValue());
					this._steps[this.stepBeingEdited - 1].expectedResSummary = this._getSummary();
				}
				var typeNode = dojo.byId(this.ID_STEP_TYPE + this.stepBeingEdited);
				if (typeNode && typeNode.stepType) 
					this._steps[this.stepBeingEdited-1].elementType = this._getElementTypeByName(typeNode.stepType);
				if (!continueEditing) {
					this.stepBeingEdited = -1;
					this.editor.disabled = true;
					this.editor.onNormalizedDisplayChanged();
				}
			}else
				this.stepBeingEdited  = -1;
		},
		onStepSave: function(target /* a row or an element within a table cell */) {
			var row = target;
			if ( target.currentTarget != null ) {
				row = target.currentTarget.parentNode.parentNode;
			}
			var stepNum = this._getStepNumForRow(row);
			var typeNode = dojo.byId(this.ID_STEP_TYPE + stepNum);
			if(typeNode == null)
				typeNode = dojo.byId(this.ID_KW_TYPE + stepNum);	
			if ( typeNode && typeNode.value && dojo.trim(typeNode.value).length == 0) {
				if (this.parentCallBack) {
					this.parentCallBack.setHeaderStatus(Constants.getMessage("msgStepTypeRequired", stepNum), 
							Constants.HEADER_STATUS_ERROR);
				}else
					alert(Constants.getMessage("msgStepTypeRequired", stepNum));
				return false;
			}			
			var content = this._steps[stepNum -1].content;
			var expectedResult = this._steps[stepNum -1].expectedResult;
			var summary = this._steps[stepNum -1].summary;
			if ( !content || dojo.trim(content).length == 0 || unescape(content).indexOf("br _moz_editor_bogus_node") != -1 || unescape(content) === '<br />') {
				var stepNumInt = parseInt(stepNum, 10);
				// ensure that the step content, expectedResult and its properties are empty before discarding it
				if( stepNumInt === this._steps.length && !(this._steps[stepNumInt -1].properties 
						&& this._steps[stepNumInt -1].properties.length > 0) && (!expectedResult || dojo.trim(expectedResult).length == 0 || 
						unescape(expectedResult).indexOf("br _moz_editor_bogus_node") != -1 || unescape(expectedResult) === '<br />') ){
					this._steps.pop();
					this._stepsTableBody.removeChild(row);
					return true;
				}else{
					if (this.parentCallBack) {
						this.parentCallBack.setHeaderStatus(Constants.getMessage("msgStepContentRequired", stepNum), 
								Constants.HEADER_STATUS_ERROR);
					}else
						alert(Constants.getMessage("msgStepContentRequired", stepNum));
					this._preserveEditedContent();
					this._attachEditor(this.ID_DETAIL_EDITOR_DIV+stepNum);
					return false;
				}
			}
			var stepObj = this._getStepByNum(stepNum);
			if ( stepObj == null ) {
				stepObj = {};
				this._steps.push(stepObj);
			}
			stepObj.num = stepNum;
			if (typeNode.stepType) stepObj.elementType = this._getElementTypeByName(typeNode.stepType);
			if (summary != null && summary.length > 0) {
				//only send up summary if changed or new
				if (!stepObj.summary || stepObj.summary != summary) {
					stepObj.summary = summary;
				}
			}
			stepObj.content = content?dojo.trim(content):"";
			stepObj.expectedResult = expectedResult ? dojo.trim(expectedResult) : "";
			if(stepObj.typeName)
				delete(stepObj.typeName);
			this._createCurrentProperties(this._steps[parseInt(stepNum, 10) -1].properties);
			stepObj.properties = this.currentProperties;
			this.removedAttachments = new Array();
			this.currentRemovedAttachments = null;
			return true;
		},
		
        _getSummary:function(text) {
            var summaryText = "";
			var contentNode = null;
			var newDiv = document.createElement("div");
			if(text){
				newDiv.innerHTML = unescape(text);
				contentNode = newDiv;
			}else if(this.editor && this.editor.editNode){
				newDiv.innerHTML = this.editor.editNode.innerHTML;
				contentNode = newDiv;
//				contentNode  = this.editor.editNode.cloneNode(true);
			}
			var node = contentNode;
			while (node && node.hasChildNodes()) {
				var firstChild = node.firstChild.cloneNode(true);
				if (firstChild.nodeType == 3) { //text node
					var text = dojo.trim(firstChild.nodeValue);
					if ( text == "" || text == "&nbsp;") {
						if(node.firstChild.nextSibling)
							firstChild = node.firstChild.nextSibling.cloneNode(true);
					}
				}
				dojox.data.dom.replaceChildren(node, firstChild);//remove all children except the first one
				var child = node.firstChild;
				if (child.nodeType == 3) { //text node
					if (child.nodeValue.length > 50) {
						child.nodeValue = child.nodeValue.substr(0, 49)+"...";
					}
					break;
				}else if (child.nodeType == 1) { //element node
						if (child.hasChildNodes()) {
							var firstChild = child.firstChild.cloneNode(true);
							if (firstChild.nodeType == 3) { //text node
								var text = dojo.trim(firstChild.nodeValue);
								if ( text == "" || text == "&nbsp;") {
									if(child.firstChild.nextSibling)
										firstChild = child.firstChild.nextSibling.cloneNode(true);
								}
							}
							dojox.data.dom.replaceChildren(child, firstChild);//remove all children except the first one
						}
						node = node.firstChild;
					}
			}
			summaryText = escape(dijit._editor.getChildrenHtml(contentNode));
			if(summaryText.length>250)
				summaryText = "";//probably contains an image and its url length is >250. Cant do anything about it
			return summaryText;            
        },
        
		setGlobalSaveInProgress: function(){
			this.prevStepNum = -2;
		},
		
		_createCurrentProperties: function(propertyArray){
			this.currentProperties =[];
			if(propertyArray){
				this.currentProperties = propertyArray;
			}
		},
		
		fClick: function(){
			var callbackObj = this.callback;
			if(!this.callback.changedStepId)
				this.callback.changedStepId = this.stepId;
			if(this.typeId)
				callbackObj.updateStepType({abrv: this.typeId})
		},

		_createContextMenu: function(nodeId,stepId){
			var callback = this;
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[nodeId]});
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelExecutionStep"), 
				iconClass: "ExecutionStepIcon", stepId: stepId, typeId:"es", callback: callback, onClick:this.fClick}));
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelReportingStep"), 
				iconClass: "ReportingStepIcon",  stepId: stepId, typeId:"rp", callback: callback, onClick:this.fClick}));
            pMenu.startup();
			//Enable the same menu for left click also			
			this.Menu = pMenu;
			this.connect(document.getElementById(nodeId), "onclick","_openPopUp");
			this.connect(document.getElementById(nodeId), "onkeypress", function(e){
				if(e.keyCode == dojo.keys.DOWN_ARROW)
					this._openPopUp(e);
				});
		},
		
		_openPopUp: function(e){
			this.changedStepId = this._getStepNumForRow(e.currentTarget.parentNode.parentNode);
			this.Menu._openMyself(e);
			return false;
		},
		
		_createInsertContextMenu:function(nodeId,rowId){
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[nodeId]});
			var callback = this;
            pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelInsertStepBelow"), 
				iconClass: "ExecutionStepIcon", 
				rowId:rowId,
				callback:callback,
				onClick:function(){
					var row = dojo.byId(rowId);
					this.callback._handleRowInsert(row,true);
				}
			}));
            pMenu.startup();
			return pMenu;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ExecutionScriptElementEditor#_error");
		},

		destroy: function() {
			this._destroyEditor();
			dojo.unsubscribe(this.dndTopic);
			this.dndTopic = null;
			dojo.unsubscribe(this.dndTopic2);
			this.dndTopic2 = null;
			if (this.stepsDndSource) {
				this.stepsDndSource.clearItems();
				this.stepsDndSource.destroy();
				this.stepsDndSource = null;
			}
			if(this._kwView)
				this._kwView.destroy();
			while (this._tooltips.length > 0)
				this._tooltips.pop().destroy();
			this.inherited(arguments);
		},

		_destroyEditor: function(){
			if(this.editor){
				try{
					this.editor.endEditing(true);
					this.editor.destroy(true);
//					this.toolbar = null;
				}catch(e){
					console.debug("Exception in _destroyEditor ESEL errorMsg -> " + e.message);
					dijit.registry.remove(this.editor.id);//couldnt destroy the editor, remove it from registry
				}
			}
			this.editor = null;
			this.stepBeingEdited  = -1;
			this._changeBGColor();
			this.lastClickedRow = "none";
			this.attachingEditor = false;
		},

		_getDatapool: function() {
			if(this.parentCallBack) {
				var datapool = this.parentCallBack.getSelectedDataPool();
				return (datapool)? datapool : null;
			}
			return null;
		},

		setParentDirty: function(){
			this.parentCallBack._setEditorDirty(true);
		},
		
		_removeAllVariables: function(){
			for(var i=0; i<this._steps.length; i++){
				if (this._steps[i].content) {
					var content = this._steps[i].content;
					content = unescape(content);
					while (true) {
						var p1 = content.indexOf("<button");
						if (p1 == -1) 
							break;
						var p2 = content.indexOf("</button>", p1 + 2);
						content = content.substring(0, p1) + content.substring(p2 + 9);
					}
					this._steps[i].content = content;
				}
			}
			this.updateSteps();
		},
		_toggleCommentsColumn:function(show){
			var val = null;
			if(show == "show")
				val = true;
			else
				val = false;
			if (val != this.showCommentsCol) {
				this.showCommentsCol = val;
				if (this.showCommentsCol) {
					dojo.style(this.comments_col, 'display', '');
					for (var i = 1; i < this._steps.length + 1; i++) {
						var commentAreaCell = document.getElementById(this.ID_COMMENT_COL_CELL + i);
						if (commentAreaCell) 
							dojo.style(commentAreaCell, 'display', '');
						var commentCell = document.getElementById(this.ID_COMMENT_CELL + i);
						if (commentCell) 
							dojo.style(commentCell, 'display', 'none');
					}
				}
				else {
					for (var i = 1; i < this._steps.length + 1; i++) {
						var commentAreaCell = document.getElementById(this.ID_COMMENT_COL_CELL + i);
						if (commentAreaCell) 
							dojo.style(commentAreaCell, 'display', 'none');
						var commentCell = document.getElementById(this.ID_COMMENT_CELL + i);
						if (commentCell) 
							dojo.style(commentCell, 'display', '');
					}
					dojo.style(this.comments_col, 'display', 'none');
				}
			}
		},
		_changeImageDisplay:function(displayType){
			if(this.imageDisplayType == displayType)
				return;
			this._preserveEditedContent();
			this.imageDisplayType = displayType;
			for (var i = 0; i < this._steps.length; i++) {
				var content = unescape(this._steps[i].content);
				this._steps[i].content = escape(this._manageImages(displayType,content));
				if(!this._steps[i].expectedResult)
					this._steps[i].expectedResult = "";
				var expectedResult = unescape(this._steps[i].expectedResult);
				this._steps[i].expectedResult = escape(this._manageImages(displayType,expectedResult));
			}
			this._showSteps();
		},
		_manageImages:function(displayType,content){
			if (displayType == "FS") {
					var newDiv = document.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						for(var k=0;k<anchors.length;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							if (images && images.length) {
								var spans = anchors[k].getElementsByTagName("SPAN");
								if(spans && spans.length )
									anchors[k].removeChild(spans[0]);
								var img = document.createElement('img');
								img.src = images[0].src;
								dojo.style(images[0],'display','inline');
								images[0].width = img.width;
								images[0].height = img.height;
								images[0].style.width = img.style.width;
								images[0].style.height = img.style.height;
							}
						}
						return dijit._editor.getChildrenHtml(newDiv);
					}else
						return content;
				}else if (displayType == "TN") {
					var newDiv = document.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						for(var k=0;k<anchors.length;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							if (images && images.length) {
								var spans = anchors[k].getElementsByTagName("SPAN");
								if(spans && spans.length )
									anchors[k].removeChild(spans[0]);
								dojo.style(images[0],'display','inline');
								var img = document.createElement('img');
								img.src = images[0].src;
								var width = img.width;
								var height = img.height;
								var ratio = height>0?width/height:1;
								if(height>50){
									images[0].width = (50*ratio);
									images[0].height = 50;
									images[0].style.width = 50*ratio+'px';
									images[0].style.height = 50+'px';
								}else if(width>50){
									images[0].width = 50;
									images[0].height = (50/ratio);
									images[0].style.width = 50+'px';
									images[0].style.height = 50*ratio+'px';
								}
							}
						}
						return dijit._editor.getChildrenHtml(newDiv);
					}else
						return content;
				}else if (displayType == "LK") {
					var newDiv = document.createElement("div");
					newDiv.innerHTML = content;
					var anchors = newDiv.getElementsByTagName("A");
					if(anchors && anchors.length){
						for(var k=0;k<anchors.length;k++){
							var images = anchors[k].getElementsByTagName("IMG");
							if (images && images.length) {
								var name = images[0].alt;
								var spanElement = document.createElement('span');
								spanElement.appendChild(document.createTextNode(' '+name+' '));
								anchors[k].insertBefore(spanElement,anchors[k].firstChild);
								dojo.style(images[0],'display','none');
							}
						}
						return dijit._editor.getChildrenHtml(newDiv);
					}else
						return content;
				}
			
		},
		_showCompactView:function(selection){
			var val = null;
			if(selection == "normal"){
				val = false;
			}else
				val = true;
			if (this.showCompactView != val) {
				this.showCompactView = val;
				this._preserveEditedContent();
				this._showSteps();
			}
		}
	}
);
})();
