/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("jazz.ui.HoverPopup");

(function() {

var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TestScriptClient		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var AlertDialog 			= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var GlobalEvents			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

dojo.declare("KeywordLibraryView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return 3;
    },
    
    getColumnHeading: function(content, index){
        var headings = [
			"",
			Constants.getMessage("labelKeywords"),
			Constants.getMessage("labelType")
        ];
        return headings[index];
    },

    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
        return false;
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex == 2);   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 10;
            case 1: 
                return 60;
            case 2: 
                return 30;
        }
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_keyword_" + rowData.elements[0].value;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;				 
        }
        return type;
    },

    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.elements[0].value;
                break;
            case 1: 
                val = rowData.elements[1].value;
                break;
            case 2: 
                val = rowData.elements[2].value;
                break;
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 0) {
           val = {};
           val.image = ImageCache.TEST_SCRIPT;
 		   val.href = rowData.link;
        }		  		  		  
        return val;
    }    
});
dojo.declare("KeywordLibraryView.TableRowRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableRowRenderer,
{
	editor:null,
	constructor :function(params){
		this.editor = params.editor;
	},
	renderRow: function(viewer, rowObject, trNode){
		if(!dojo.hasClass(trNode.parentNode,"dojoDndSource")){
			if(this.dndSource)
				this.dndSource.destroy();
			this.dndSource= new dojo.dnd.Source(trNode.parentNode,
				{
					accept:[],
					copyOnly:true,
					singular:true,
					creator:this._dndCreator
				});
		}
		var anchor = document.createElement('a');
        var img = document.createElement('img');
        img.src = ImageCache.TEST_SCRIPT;
		img.alt = "Title";
		anchor.href = "#";
		anchor.appendChild(img);
        var td = document.createElement("td");
		td.appendChild(anchor);
        viewer.tooltips.push(new jazz.ui.HoverPopup({html: Constants.getMessage("msgDragAndDropKeyword"), around:[img]}));
        trNode.appendChild(td);
        for (var j =1; j<rowObject.elements.length-1; j++){
            var element = rowObject.elements[j];
			var td = document.createElement("td");
            td.appendChild(document.createTextNode(element.value));
            trNode.appendChild(td);
        }
        var editorId = rowObject.elements[rowObject.elements.length-1];
        trNode["editorId"] = editorId;
		trNode.id = "_tr"+editorId+rowObject.elements[0].value; //0 contains the ID
		this._attachContextMenu(trNode,rowObject.scriptObj);
		this.dndSource.setItem(trNode.id, {data: rowObject, type: [editorId]});
		dojo.addClass(trNode, "dojoDndItem");
    },
	
	clearRowStates: function(){
		if(this.dndSource)
        	this.dndSource.clearItems();
    },

    _dndCreator:function(row,hint){
        if(hint == "avatar"){
			var text = document.createTextNode(row.elements[1].value);
			var span =document.createElement("span");
			span.appendChild(text);
            var editorId = row.elements[row.elements.length-1];
            return {node: span, data: row, type: [editorId]};
		}			
	},
	_attachContextMenu: function(node,scriptObj){
		var callback = this;
		if(node){
			var pMenu = new dijit.Menu({targetNodeIds:[node]});
            pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelInsertBefore"),
				scriptObj: scriptObj, 
				callback: callback, 
				onClick:this._insertKeyword}));
            pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelReplaceStatement"),
				scriptObj: scriptObj, 
				callback: callback, 
				onClick:this._replaceCurrentWithKeyword}));
            pMenu.startup();	
		}
	},
	
	_replaceCurrentWithKeyword: function(){
		var editor = this.callback.editor;
		if(editor){	if(editor.lastClickedRow != "none" && editor.lastClickedRow != ""){
				var row = dojo.byId(editor.lastClickedRow);
				editor._addKeyword(row, this.scriptObj,true);
			}else
				this._displayAlertDialog(Constants.getMessage("msgNoStepToReplace"));
		}		
	},
	_insertKeyword: function(){
		var editor = this.callback.editor;
		if(editor){
			if(editor.lastClickedRow != "none" && editor.lastClickedRow != ""){
				var row = dojo.byId(editor.lastClickedRow);
				editor._addKeyword(row, this.scriptObj,false);
			}else
				this._displayAlertDialog(Constants.getMessage("msgNoStep"));
		}
	}		
});		
dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/KeywordLibraryView.html"),
		
		labelKeywordView: Constants.getMessage("labelKeywordView"),
		editor:null,
		constructor: function() {
		},
		
		postCreate: function() {
			this._isShowing = (this.open != null) ? !this.open : false;
            this._showHide.onclick = dojo.hitch(this, "_clickArrow");
			this._showBar.onmouseover = this._showBar.onmouseout = dojo.hitch(this, "_mouseHandler");
            this._panelCache = {};
            this._onAnimationEnd();
			this.rows = [];
			var responseHandler = new ServiceResponseHandler(this, "_fillScripts", "_error");
			try{
				com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {});
			}catch(e){
				console.debug("getKeywords failed in KeywordLibraryView");
			}
			//cshelp
			if (this._cshelp) {
		        var cshelp = new CSHelp({
		        	contextID: "rqm_keyword_view.html"
		        });
				cshelp.setButtonLabel(Constants.getMessage("labelKeywordLibCSHelp"));
		        this._cshelp.appendChild(cshelp.domNode);
			}
			this.dndTopic = dojo.subscribe("/dnd/drop",this, "_dndDrop");
			this.stepsDndSource = new dojo.dnd.Target(this.keywordView, {
					accept: [ this.editor.ID_SUMMARY_ROW],
					copyOnly:true,
					selfAccept:false,
					selfCopy:false,
					creator:this._dndCreator
				}); 
		},
		_dndDrop:function(source,nodes,iscopy,target){
			if(target.accept[this.editor.ID_SUMMARY_ROW])
				setTimeout(dojo.hitch(this, "showNewKeywordDialog",nodes),0);
		},
		showNewKeywordDialog:function(nodes){
			if(!nodes || !nodes.length)
				return;
			this.droppedSteps = nodes;
			var args = {
	            itemType: Constants.MODEL_TYPE_KEYWORD,
	            onOkCallback: dojo.hitch(this, "_handleAddNewItem"),
				showAssociate:false,
				okCallbackData:nodes
        	}
			this.keywordPopup = new com.ibm.rqm.planning.web.ui.internal.view.construction.NewKeywordPopup(args);
		},
		_dndCreator:function(row,hint){
			var newRow = document.createElement("tr");	
            return {node: newRow, data: null, type: []};
		},
		_handleAddNewItem:function(nodes){
			var newItem = this.keywordPopup.getItemForDisplay();
			var self = this;
	        var handler = {
	            success: function(testScript) {
	                self._createKeyword(testScript, newItem);
	            },
	            error: function(e) {
	                self._error(e);
	            }
	        }
			var steps = [];
			this.editor._preserveEditedContent();
			for(var i=0;i<nodes.length;i++){
				steps.push(this.editor._getStepForRow(nodes[i]));
			}
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");	
			var scriptObj = {
				name: newItem.name,
				type: "Manual",
				description: Constants.getMessage("labelKeywordDesc"),
				newScript: true,
				state:Constants.STATETRANSITION_STATE_DRAFT,
				elements:steps
			};
			TestScriptClient.saveTestScript(responseHandler, scriptObj);
		},
		_createKeyword:function(testScript,newItem){
			var responseHandler = new ServiceResponseHandler(this, "_createFinished", "_error");	
			var keywordObj = {
				newKeyword:true,
				name: newItem.name,
				tags: newItem.tags,
				manualScript:testScript.versionableItemId  ? testScript.versionableItemId: testScript.itemId,
				defaultScript:testScript.versionableItemId ? testScript.versionableItemId: testScript.itemId
			};
			com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.postKeywordDTO(responseHandler, keywordObj);
		},
		_createFinished:function(keyword){
			dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_KEYWORD, [keyword]]);
			var args = {
            	'message': Constants.getMessage("msgReplaceStepsWithKeyword"),
            	'yesCallback':dojo.hitch(this,"_replaceStepsWithKeyword"),
            	'yesCallbackData': keyword,
            	'noCallback': dojo.hitch(this,function(){this.droppedSteps = null;}),
            	'noCallbackData': null
        	};
        	var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        	confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			confirmDialog.open();
		},
		_replaceStepsWithKeyword:function(keyword){
			if (this.droppedSteps && this.droppedSteps.length > 0) {
				this.editor._addKeyword(this.droppedSteps[0], keyword, true,true);
				for (var i = 1; i < this.droppedSteps.length; i++) {
					this.droppedSteps[i].parentNode.removeChild(this.droppedSteps[i]);
				}
				this.editor._reOrganizeSteps();
			}
			this.droppedSteps = null;
		},
		_fillScripts: function(keywords){
			if(keywords){	
				for(var i=0;i<keywords.length ; i++){
					if(keywords[i].archived)
						continue;
					var script = keywords[i].defaultScript ? keywords[i].defaultScript:keywords[i].manualScript;
					var type =  Constants.getExtensionDisplayMessage(script.scriptType.name);
					if(script.scriptType.name == "Manual")
						type = Constants.getMessage("labelManual");
					var scriptId = script.id;
					this.rows.push({
						elements: [ { value: keywords[i].id},
									{ value: keywords[i].name},
									{value: type},
									this.editor.id],
						scriptObj: keywords[i]				
					});
				}
			}	
			this._displayTable();
		},
		
		_displayTable: function(){
			if (!this.tableViewer) {
				this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({tooltips:[]});
				this.tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelKeywordView")));
				this._tableViewerNode.appendChild(this.tableViewer.domNode);
				var keywordRowRenderer = new KeywordLibraryView.TableRowRenderer({
					editor: this.editor
				});
				this.tableViewer.setCustomRowRenderer(keywordRowRenderer);
				this.tableViewer.setContentPageSize(10);
				this.tableViewer.setContent(this.rows);
				this.tableViewer.setContentProvider(new KeywordLibraryView.TableProvider());
				this.tableViewer.show();
				//need to do this tweaking to keep the keyword library view from not getting too wide
				var pageSelectParent = this.tableViewer.PageSelectControlNode.parentNode;
				if (pageSelectParent) 
					pageSelectParent.parentNode.removeChild(pageSelectParent);
				var actionsAreaParent = this.tableViewer.actionsAreaNode.parentNode;
				if (actionsAreaParent) 
					actionsAreaParent.parentNode.removeChild(actionsAreaParent);
				var pageControlParent = this.tableViewer.PageControlNode.parentNode;
				if (pageControlParent) 
					pageControlParent.removeAttribute('nowrap');
			}else{
				this._refreshTable(this.rows);
			}
		},
		_refreshTable:function(content){
			this.tableViewer.setContent(content);
			this.tableViewer.refresh();
		},
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') in KeywordLibrary#_error");
			
		},
		destroy: function(){
			dojo.unsubscribe(this.dndTopic);
			this.dndTopic = null;
			if(this.stepsDndSource){
				this.stepsDndSource.destroy();
			}
			while (this.tableViewer.tooltips.length > 0)
				this.tableViewer.tooltips.pop().destroy();
			this.inherited(arguments);
		},
			
		_mouseHandler: function(event) {
			var type;
			if( dojo.isIE && !event )
			{
				type = window.event.type;
			}
			else
				type = event.type;
			
			if(this._isShowing && type == "mouseout"){
				this._innerBar.style.display = "none";
				dojo.removeClass(this._showBar, "show-bar");
				dojo.addClass(this._showBar, "show-bar-open-inactive");
			}else if(this._isShowing && type == "mouseover"){
				this._innerBar.style.display = "block";
				dojo.removeClass(this._showBar, "show-bar-open-inactive");
				dojo.addClass(this._showBar, "show-bar");
			}
		},
        
        _clickArrow: function(e) {
            var args = {
                node: this.domNode.parentNode,
                duration: 200,
                properties: {
                    width: {unit: "px"}
                },
                onEnd: dojo.hitch(this, "_onAnimationEnd")
            };
				
            if (this._isShowing) {
                // hide
				this.keywordView.style.display = "none";
                args.properties.width.start = 225;
                args.properties.width.end = 10;
            } else {
                // show
                args.properties.width.start = 10;
                args.properties.width.end = 225;
            }
            
            var anim = dojo.animateProperty(args);
            anim.play();
        },
            
        _onAnimationEnd: function() {
            if (this._isShowing) {
                dojo.removeClass(this._showHide, "arrow-right");
                dojo.addClass(this._showHide, "arrow-left");
                this._isShowing = false;
				this._innerBar.style.display = "block";
				dojo.removeClass(this._showBar, "show-bar-open-inactive");
				dojo.addClass(this._showBar, "show-bar");
				this.editor._setColWidths();
				//For defect 10092: deal with Chrome separately
				if(navigator.userAgent.indexOf("Chrome") >= 0)
					this._showHide.style.left = (this._showBar.offsetLeft + 10) + "px";
            } else {
                dojo.removeClass(this._showHide, "arrow-left");
                dojo.addClass(this._showHide, "arrow-right");
                this._isShowing = true;
				this._innerBar.style.display = "none";
				dojo.removeClass(this._showBar, "show-bar");
				dojo.addClass(this._showBar, "show-bar-open-inactive");
				this.keywordView.style.display = "block";
				this.editor._setColWidths();
				//For defect 10092: deal with Chrome separately
				if(navigator.userAgent.indexOf("Chrome") >= 0)
					this._showHide.style.left = "";
            }
			if(dojo.isFF == 2)
				this.parent.switchBidiContentArea(this._isShowing);
        },
		onArtifactChanged: function(changeType, artifactType, artifactArray){
			if (changeType == GlobalEvents.ArtifactsAdded ){
				this._fillScripts(artifactArray);
			}else {
				for(var i=0;i<artifactArray.length;i++){
					for(var j=0;j<this.rows.length;j++){
						if(this.rows[j].elements[0].value == artifactArray[i].id){
							if(artifactArray[i].archived)
								this.rows.splice(j,1);
							else{
								var script = artifactArray[i].defaultScript ? artifactArray[i].defaultScript:artifactArray[i].manualScript;
								var type =  Constants.getExtensionDisplayMessage(script.scriptType.name);
								var scriptId = script.id;
								var row ={
									elements: [ { value: artifactArray[i].id},
												{ value: artifactArray[i].name},
												{value: type},
												this.editor.id],
									scriptObj: artifactArray[i]
								};
								this.rows.splice(j,1,row);
							}	
						}
					}	
				}
				this._displayTable();
			}	
		},
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        }

	}
);

})();
