/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.DomConstructor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var CSHelp = com.ibm.asq.common.web.ui.internal.util.CSHelp;
	var SelectUtility = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
    /**
     *
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.NewSectionDialog", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/NewSectionDialog.html"),
        
		labelSectionName: Constants.getMessage("labelSectionName"),
		labelDescription: Constants.getMessage("labeldescription"),
		labelApplyToTemplate: Constants.getMessage("labelApplyToTemplate"),
		labelOk: Constants.getMessage("labelOk"),
        labelCancel: Constants.getMessage("labelCancel"),
        labelTypeOfSection: Constants.getMessage("labelTypeOfSection"),
		        
        constructor: function(args){},
        
        postCreate: function(){
			if (!dojo.isFunction(this.onOk)) {
				throw new Error("Parameter 'onOk' is REQUIRED and must be a Function.");
			}
			
			this._applyTemplateCheckbox.style.display = "none";
			this._applyTemplateLabel.style.display = "none";
			this._messages.style.display = "none";
			
            var dialogArgs = {
				primaryTitle: Constants.getMessage("labelNewSection"),
                okCallback: dojo.hitch(this, "_onOk"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				_truncate: function() {}  //disable the Dialog's '_truncate'
            };      
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth("500px");
			var cshelp = new CSHelp({contextID: "rqm_new_custom.html"});
			cshelp.setButtonLabel(Constants.getMessage("labelNewSectionCSHelp"));
			this._dialog.setSecondaryTitleNode(cshelp.domNode);
			this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.getOkButton().disabled = false;
            this._dialog.open();		
			
			var opt = new Option(Constants.getMessage("labelRichTextEditor"), Constants.DYNAMICSECTION_RICHTEXT);
			var opt1 = new Option(Constants.getMessage("labelGrid"), Constants.DYNAMICSECTION_GRID);
			SelectUtility.add(this._typeCombo, opt);
			SelectUtility.add(this._typeCombo, opt1);
			dojo.connect(this._typeCombo, "onchange", this, "_handleTypeChange")
			
			setTimeout(dojo.hitch(this, function() {this._name.focus()}), 250);		
        },
        
        _onCancel: function() {
			if (this._dialog) {
				//this.floatingPane.close();  //removed --> SelectionDialog closes itself on cancel
				//dojox.data.dom.removeChildren(this.floatingPane.containerNode);
				this._dialog = null;
			}			
        },
        
        _onOk: function() {
			this._messages.style.display = "none";
            if (this._name.value == null || dojo.trim(this._name.value).length == 0) {
				dojox.data.dom.removeChildren(this._messages);
				this._messages.style.display = "inline";
				this._messages.appendChild(document.createTextNode(Constants.getMessage("labelSectionNameRequired")));
				return false;
            } else {
				 var id = this._typeCombo.value == Constants.DYNAMICSECTION_GRID ? Constants.DYNAMICSECTION_GRID_ID + new Date().getTime() 
				 								: Constants.DYNAMICSECTION_RICHTEXT_ID + new Date().getTime();
				if(this._typeCombo.value == Constants.DYNAMICSECTION_GRID && (!this._maxCol || isNaN(this._maxCol))){
					dojox.data.dom.removeChildren(this._messages);
					this._messages.style.display = "inline";
					this._messages.appendChild(document.createTextNode(Constants.getMessage("msgColumnNumberInvalid")));
					return false;
				}
				if (dojo.isFunction(this.onOk)) {
					var params = {type: this._typeCombo.value};
					if(this._typeCombo.value == Constants.DYNAMICSECTION_GRID){
						var colNames = [];
						for(var i=0;i<this._maxCol;i++){
							 var col = document.getElementById("col_"+ i);
							 if(!col || !col.value || dojo.trim(col.value).length == 0){
							 	dojox.data.dom.removeChildren(this._messages);
								this._messages.style.display = "inline";
								this._messages.appendChild(document.createTextNode(Constants.getMessage("msgColumnNameInvalid", (i+1) ) ) );
								return false;
							 }
							 colNames[i] = col.value;
						}
						params.configurationData = dojo.toJson(colNames);
					}
	                this.onOk(id, this._name.value, this._description.value, params);
	            }		
            }
        },
        
        _onKeyup: function(e){
/*
enter key on any one of the text fields should not close the dialog 
            if (e.keyCode == dojo.keys.ENTER) {
                if (this._dialog) {
					this._dialog.getOkButton().onclick();
				}
            }
*/
        },
		
		gridDetailTemplate: "<div>"+
							"<div><label dojoAttachPoint=\"numLabel\"></label><input type=\"text\ size=\"2\" dojoAttachPoint=\"_maxColInputBox\"></input><img dojoAttachPoint=\"_changeColumnNamesImg\"></img></div>"+
							"<label dojoAttachPoint=\"colNamesLabel\"></label>"+
							"<table><tbody dojoAttachPoint=\"_colTbody\">"+
							"</tbody></table>"+
							"</div>",

		_handleTypeChange: function(){
			this._maxCol = null;
			dojox.data.dom.removeChildren(this._detailsNode);
			if(this._typeCombo.value == Constants.DYNAMICSECTION_GRID){
				this.selectionArea = new com.ibm.asq.common.web.ui.internal.util.DomConstructor(this.gridDetailTemplate);
				this.selectionArea._changeColumnNamesImg.alt = Constants.getMessage("labelEnterColumnNames");
				this.selectionArea._changeColumnNamesImg.title = Constants.getMessage("labelEnterColumnNames");
				this.selectionArea._changeColumnNamesImg.src = ImageCache.EDIT;
				this.selectionArea.numLabel.innerHTML = Constants.getMessage("labelNumOfCol");
				this.selectionArea.colNamesLabel.innerHTML = Constants.getMessage("labelColumnNames");
				this._detailsNode.appendChild(this.selectionArea.domNode);
				dojo.connect(this._maxColInputBox, "onkeyup", this, "_updateMaxCol");
				this.updateColNamesAction = dojo.connect(this.selectionArea._changeColumnNamesImg, "onclick", this, "_updateTableRows")
			}
		},
        
		_updateMaxCol: function(){
			this._maxCol = parseInt(this.selectionArea._maxColInputBox.value);
			if(!this._maxCol || isNaN(this._maxCol)){
				dojox.data.dom.removeChildren(this._messages);
				this._messages.style.display = "inline";
				this._messages.appendChild(document.createTextNode(Constants.getMessage("msgColumnNumberInvalid")));
				dojo.disconnect(this.updateColNamesAction);
				this.updateColNamesAction = null;
				return;
			}else{
				this._messages.style.display = "none";
				this.updateColNamesAction = dojo.connect(this.selectionArea._changeColumnNamesImg, "onclick", this, "_updateTableRows")
			}
		},
		
		_updateTableRows: function(){
			this._messages.style.display = "none";
			dojox.data.dom.removeChildren(this.selectionArea._colTbody);
			for(var i=0;i<this._maxCol;i++){
				var tr = document.createElement('tr');
				var td = document.createElement('td');
				var inputBox = document.createElement('input');
				inputBox.value = "Column " + (i+1);
				inputBox.id = "col_"+i; 
				td.appendChild(inputBox);
				tr.appendChild(td);
				this.selectionArea._colTbody.appendChild(tr);
			}
		}
    });
})();
