/**ManualExecProps******************************************************************* 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties");

//Dojo widget
dojo.require("dojox.data.dom");
dojo.require("dijit.form.Button");
dojo.require("dojo.parser");
dojo.require("jazz.ui.HoverPopup");

dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.defects.web.client.ChangeRequestManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.rqm.defects.web.util.ItemPickerUtil");
dojo.require("com.ibm.rqm.defects.web.client.internal.CmIntegrationClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.ApplyAllConfirmationDialog");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.defects.web.helper.RemoteItemPicker");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function() { // module container
var HoverPopup 						= jazz.ui.HoverPopup;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;

var TeamServerClient 				= com.ibm.team.repository.web.transport.TeamServerClient;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;

var DOWNLOAD_SERVICE_URI 			= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var DEFECT_URL 						= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var DefectView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;
var AttachmentView					= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView;
var CommentView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView;
var CompareView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;

var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var NewDefectDataInitializer        = com.ibm.rqm.execution.web.ui.internal.view.common.NewDefectDataInitializer;

var ChangeRequestManager			= com.ibm.rqm.defects.web.client.ChangeRequestManager;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;
var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var DeferredDialog					= com.ibm.rqm.defects.web.ui.view.common.DeferredDialog;
var ItemPickerUtil					= com.ibm.rqm.defects.web.util.ItemPickerUtil;

var RemoteItemPicker				= com.ibm.rqm.defects.web.helper.RemoteItemPicker;
var CmIntegrationClient				= com.ibm.rqm.defects.web.client.internal.CmIntegrationClient;

var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_TYPE					= "keyword";
var Status                          = "com.ibm.team.repository.web.foundation.Status";
var CSHelp 							= com.ibm.asq.common.web.ui.internal.util.CSHelp;

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecutionProperties",null,{
		ewi: null,
		script: null, 
		testcase: null,
		_steps: [],
		_currentStepNumber: 0,
		parentController: null,
		originalStepNum: null,
		//for Datapool: 
		_cells: [],
		keywordsWithoutVerdicts:[],
		defectTooltipMap: {},

		_showDefect:function(stepNum, propertyType){
			defectProps = [];
			var props = this.stepProperties[stepNum];
			if(props){
				for(var i=0;i<props.length ;i++)
					if(props[i].propertyType == propertyType)
						defectProps.push(props[i]);
			}
			this._defectIconClicked("show",defectProps,null);
		},
		
		_showDefectByPress: function(e, stepNum, image) {
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13 && this._showDefect) {
				image.blur();
				this._showDefect(stepNum);
			}
		},
		
		_showAttachByPress: function(event, attachUrl) {
			var charCode = (event.keyCode) ? event.keyCode : event.which;
			if(charCode == 13)
				window.open(attachUrl, "_blank");
		},
		_getEmptyCell: function(span, align) {
			var cell = document.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			return cell;
		},		
		_createPropertiesHtml: function(stepNum,properties){
			var attachCell = this._getEmptyCell();
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
			var defectCell = this._getEmptyCell();
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right";
			var commentCell = this._getEmptyCell();
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right";
			var compareCell = this._getEmptyCell();
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right";

			var defectFound = false; var attachmentFound = false; var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var defectsHtml = document.createElement("span");
			var defectsHtmlTable = defectsHtml.appendChild(document.createElement("table"));
			var defectsHtmlContent = defectsHtmlTable.appendChild(document.createElement("tbody"));
			var attachmentsHtml = document.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(document.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(document.createElement("tbody"));
			var commentsHtmlContent = document.createElement("span");
			if(properties){
				for(var i=0;i<properties.length;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
						if(defectFound == false){
							var defectImg = document.createElement("img");
							defectImg.alt= Constants.getMessage("labelDefects");
							defectImg.src = ImageCache.DEFECT;
							defectImg.className = "type-image";
							defectImg.setAttribute("tabIndex", 0);
							defectImg.id = this.DEFECT_ICON + stepNum;
							defectCell.appendChild(defectImg);
							if (dojo.isIE) {
									defectImg.onkeypress = dojo.hitch(this, function(event){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
								else {
									defectImg.onkeypress = dojo.connect(defectImg, "onkeypress", this, function(e){
										if(this.defectTooltipMap[stepNum])
											this.defectTooltipMap[stepNum].open();
									});
								}
							dojox.data.dom.removeChildren(defectsHtmlContent);
							defectFound = true;
						}							
						defectCount++;							
						var defectsHtmlContentRow = this._getEmptyRow();
						var defectsHtmlContentCell = this._getEmptyCell();
						var defectsAnchor = document.createElement("a");
						var defectLabel = document.createElement('label');
						if(properties[i].propertyType == DEFECT_VIEW_TYPE){
							defectLabel.innerHTML = Constants.getMessage("labelDefectIdExecution",  properties[i].propertyValue);
							defectsAnchor.href = DEFECT_URL + properties[i].propertyValue;
						}else if (properties[i].propertyType == RTC_DEFECT_VIEW_TYPE){
							defectLabel.innerHTML = properties[i].propertyName;
							defectsAnchor.target = "_blank";
							defectsAnchor.href = properties[i].propertyValue;
						}
						defectLabel.style.cursor = "pointer";
						defectsAnchor.setAttribute("tabIndex", 0);
						defectsAnchor.appendChild(defectLabel);	
						defectsHtmlContentCell.appendChild(defectsAnchor);
						defectsHtmlContentRow.appendChild(defectsHtmlContentCell);
						defectsHtmlContent.appendChild(defectsHtmlContentRow);
						break;
						
						case ATTACHMENT_VIEW_TYPE:
						case RESULT_ATTACTMENT_VIEW_TYPE:
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							var attachUrl = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							if(attachmentFound == false){
								var attachImg = document.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachImg.id = this.ATTACH_ICON + stepNum;	
								attachImg.setAttribute("tabIndex", 0);							
								attachCell.appendChild(attachImg);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
								if (dojo.isIE) {
									attachImg.onkeypress = dojo.hitch(this,function(){
										this._showAttachByPress(event, attachUrl);
									});
								}
								else {
									attachImg.onkeypress = dojo.connect(attachImg, "onkeypress", this, function(e){
										this._showAttachByPress(e, attachUrl);
									});
								}
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow();
							var attachmentsHtmlContentCell = this._getEmptyCell();
							var attachmentsAnchor = document.createElement("a");
							attachmentsAnchor.target = "_blank";
							attachmentsAnchor.appendChild(document.createTextNode(attachmentsText));
							attachmentsAnchor.href = attachUrl;
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;

						case COMMENT_VIEW_TYPE:
							commentFound = true;
							dojox.data.dom.removeChildren(commentsHtmlContent);
							commentsHtmlContent.appendChild(document.createTextNode(properties[i].propertyValue));
							var commentImg = document.createElement("img");
							commentImg.alt= Constants.getMessage("labelComment");
							commentImg.src = ImageCache.COMMENT;
							commentImg.className = "type-image";
							commentImg.id = this.COMMENT_ICON + stepNum;
							commentImg.setAttribute("tabIndex", 0);
							commentCell.appendChild(commentImg);
							if(this.showCommentsCol)
								dojo.style(commentCell,'display','none');
							break;
						case COMPARE_VIEW_TYPE:
							if(!dojo.byId(this.COMPARE_ICON + stepNum)){
								var compareButton = document.createElement("button");
								if(dojo.isIE >= 7)
									compareButton.style.backgroundColor = '#FFFFFF';
								else
									compareButton.style.background = "inherit";
								compareButton.style.border="0pt";
								var compareImg = document.createElement("img");
								compareImg.alt= Constants.getMessage("labelCompare");
								compareImg.src = ImageCache.COMPARE;
								compareImg.className = "type-image";
								compareImg.setAttribute("tabIndex", 0);
								compareButton.id = this.COMPARE_ICON + stepNum;
								compareButton.appendChild(compareImg);
								compareCell.appendChild(compareButton);
								dojo.connect(compareButton, "onclick", this,dojo.hitch(this,"_showCompareDialog",stepNum,null));
								break;
							}
						default:
							//do Nothing
					}
				}	
			}
			var tooltip;
			if(attachmentCount>0){
				var _attachmentTooltipSpan = document.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = document.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({around: [attachImg],html: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
			}
			if(defectCount>0){
				var _defectTooltipSpan = document.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = document.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				tooltip = new HoverPopup({
					around: [defectImg],
					html: defectsHtml.innerHTML
				});
				if(this.defectTooltipMap[stepNum])
					this.defectTooltipMap[stepNum].destroy();
				this.defectTooltipMap[stepNum] = tooltip;				
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = document.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({around: [commentImg],html:commentsHtmlContent.innerHTML}, _commentTooltipSpan);				
			}
			return [attachCell,defectCell,commentCell,compareCell];
		},
		_showDefect:function(stepNum, propertyType){
			defectProps = [];
			var props = this.stepProperties[stepNum];
			if(props){
				for(var i=0;i<props.length ;i++)
					if(props[i].propertyType == propertyType)
						defectProps.push(props[i]);
			}
			this._defectIconClicked("show",defectProps,null);
		},
		
		_showDefectByPress: function(e, stepNum, image) {
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13 && this._showDefect) {
				image.blur();
				this._showDefect(stepNum);
			}
		},
		
		_showAttachByPress: function(event, attachUrl) {
			var charCode = (event.keyCode) ? event.keyCode : event.which;
			if(charCode == 13)
				window.open(attachUrl, "_blank");
		},
		_addNewDefectViaPicker: function(currentProvider){
			var self = this;
			var summary = this.ewi.name != this.ewi.testCase.name ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name) ;
            // ... it's description ...
            var desc = Constants.getMessage("labelTestScriptFailed", this.script.name);
            
            if (this.parentSection.parentEditor.envWidget.showEnvDetails) {
                var environment = this.parentSection.parentEditor.envWidget.ewiConfig;
                desc += Constants.getMessage("labelEnvironmentWithColon");
                for (var i = 0; i < environment.envTypes.length; i++) {
                    desc += environment.envTypes[i] + ": " + environment.envValue[i] + "\r\n";
                }
            }
            desc += Constants.getMessage("labelToProduce");
            for (var i = 0; i <= this._currentStepNumber; i++) {
            	var stepText = dojo.trim(unescape(this._steps[i].content));
				//remove all html tags
            	stepText = stepText.replace(/<[^>]*?>/g, "");
            	if(stepText.indexOf('<br />') > -1)
                    stepText = stepText.replace("<br />", "");
                desc += (i + 1) + ") " + stepText + "\r\n";
            }
            
            desc += Constants.getMessage("labelObserve");
	      	var creationUrl = null;
            if (currentProvider.providerUris.defaultCreationDialogURI.indexOf("?") > -1) {
               	creationUrl = currentProvider.providerUris.defaultCreationDialogURI + "&" + ItemPickerUtil.getWICreationDialogParamString(summary, desc);
            } else {
				creationUrl = currentProvider.providerUris.defaultCreationDialogURI;	
			}
			var params= {
	            dialogTitle: Constants.getMessage("labelAddNewDefect"),
	            secondaryTitle: " ",
				pickerURL: creationUrl,
				height: currentProvider.providerUris.creationDialog.height,
				width: currentProvider.providerUris.creationDialog.width,
				parentElement: this.domNode,
				onOk: dojo.hitch(this, function(result) {
					console.debug(result);
					var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
					if (workItems.length > 0) {
						var workItem = workItems[0];
						var linkDescription = {
							id: workItem.id,
							url: workItem.url,
							linkComment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name),
							rqmUrl: this._getEwiUri() + "?runScript=" + this.runScriptId +"&_resultId="+this._resultId,
							linkType: ChangeRequestManager.LINK_TYPE_AFFECT_ER
						};
						ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
							currentProvider.postLink(linkDescription, dojo.hitch(this, function(status){
								monitor.done();
								if (status.isOK()) {
									var callback = dojo.hitch(this, function(){
										this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(workItem));
										this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
									});
									
									this._postLinkToTER(this.ewiItemId, workItem, callback);
								}
								else 
									if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
										status.log();
										this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
									}
							}));
						}));
					}
				}),
				onClose: function() {
				    console.debug("close!");
				}
	
	        };	            
	        new RemoteItemPicker(params);
		},
		
		_addExistingDefectViaPicker: function(currentProvider){
			var self = this;
			
			var defectSelectionDialog = currentProvider.services.getSelectionDialog("defect", true);
			var params= {
	            dialogTitle: Constants.getMessage("labelAddExistingDefect"),
            	secondaryTitle: " ",
				pickerURL: defectSelectionDialog.uri,
				height: defectSelectionDialog.height,
				width: defectSelectionDialog.width,
				parentElement: this.domNode,
				onOk: dojo.hitch(this, function(result) {
					console.debug(result);
				
					var workItems = currentProvider.linkType == ChangeRequestManager.PROVIDER_LINK_TYPE_CQREST ? ItemPickerUtil.parseFromCQ(result) : ItemPickerUtil.parseFromRTC(result);
					if (workItems.length > 0) {
						var workItem = workItems[0];
						var linkDescription = {
							id: workItem.id,
							url: workItem.url,
							linkComment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name),
							rqmUrl: this._getEwiUri() + "?runScript=" + this.runScriptId+"&_resultId="+this._resultId,
							linkType: ChangeRequestManager.LINK_TYPE_AFFECT_ER
						};
						ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
							currentProvider.postLink(linkDescription, dojo.hitch(this, function(status){
								monitor.done();
								if (status.isOK()) {
									var callback = dojo.hitch(this, function(){
										this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(workItem));
										this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
									});
									this._postLinkToTER(this.ewiItemId, workItem, callback);
								}
								else 
									if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
										status.log();
										this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
									}
							}));
						}));
					}
				}),
				onClose: function() {
				    console.debug("close!");
				}
	
	        };	            
	        new RemoteItemPicker(params);
		},
		
		_postLinkToTER: function(ewiItemId, workItem, callback){
			//Post local link to TER
			var postLinkToTER = dojo.hitch(this, function(monitor){
				var linkParams = {
					itemId: ewiItemId,
					cmUri: workItem.url,
					id: workItem.id,
					summary: workItem.summary,
					linkType: CmIntegrationClient.RESULT_RELATEDTO_DEFECT
				};
				CmIntegrationClient.postNewLink(linkParams, dojo.hitch(this, function(status){
					monitor.done();
					callback();
                }));
			});
			ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor){
				postLinkToTER(monitor);
			}));
		},
		
		_getEwiUri: function() {
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + this.ewiItemId;
			return result;
		},

		_listAssociatedDefectsViaProvider: function() {
			var listDialog= AssociatedWorkItemViewer.create(this.ewiItemId, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, false);
		},
		
		_defectIconClicked: function(contextMenuSelection,properties,e){
			ChangeRequestManager.getInstance().getCurrentServiceProvider(dojo.hitch(this, function(currentProvider){
	            if (currentProvider != null){
					this._dispatchDefectActionViaProvider(contextMenuSelection, properties, currentProvider);
				} else {
					this._defectIconClicked2(contextMenuSelection,properties,e);
				}
	        }));
		},
		
		_dispatchDefectActionViaProvider: function(contextMenuSelection,properties,currentProvider) {
			if (!contextMenuSelection || contextMenuSelection == "new") {
				if (this._resultId != null) 
					this._addNewDefectViaPicker(currentProvider);
				else {
					this.onApply(true, dojo.hitch(this, "_dispatchDefectActionViaProvider", contextMenuSelection, properties, currentProvider));
					this._toggleApplyButton(false);
				}
			} else if (contextMenuSelection == "existing") { 
				this._addExistingDefectViaPicker(currentProvider);
			} else if (contextMenuSelection == "show") {
				this._showDefectViaProvier(properties)
			} else {
				this._listAssociatedDefectsViaProvider();
			}
		},
		
		_defectIconClicked2: function(contextMenuSelection,properties,e){
			if(!this._defectView)
			    // specify the parent editor for the defectView to query related defects cached by the editor
				this._defectView = new DefectView({parentEditor: this.parentSection.parentEditor});
			if(!properties)	
				this._defectView.setData(this.propertiesMap[DEFECT_VIEW_TYPE].elements);
			else
				this._defectView.setData(properties);
			if(!contextMenuSelection)
				contextMenuSelection = "new";
			var dialogArgs = {
				primaryTitle: this.labelDefectsView,
	            isClosable: true,
				showActions:false,
				movable: true,
				style: "z-index: 100;",
				zIndex : 100
            };
			if (contextMenuSelection != "show") {
				dialogArgs.onClose = dojo.hitch(this, function(){
					this._checkAndupdateBlockingDefectList(this._defectView.isBlockingDefect(), this.propertiesMap[DEFECT_VIEW_TYPE].elements, this._convertProperties(this._defectView.getData()))
					this.propertiesMap[DEFECT_VIEW_TYPE].elements = this._convertProperties(this._defectView.getData());
					this._updateCurrentStepProps(DEFECT_VIEW_TYPE);
				});
                
                if(contextMenuSelection != "new")
				    this._defectView.setViewType(contextMenuSelection);
			}
			else
				this._defectView.setViewType("list");
                
            this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
			this._defectView.setParentDialog(this._defectsViewer);
			this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
			var self = this;
			this._defectsViewer._onClose = function(){
				if(dojo.isIE)
					self._defectsViewer.contentContainer.removeChild(self._defectView.domNode);
				this.destroy();//dont destroy recursive;
			}
            
            // this is a opening a new defect, get the initial seed values for the form.
            // Don't open the form until we've fetched all related data.
            if (contextMenuSelection == "new") {
               NewDefectDataInitializer.getDefectSeedValuesFromEWI(this.ewi, dojo.hitch(this, "_initNewDefectForm"));
			   var cshelp = new CSHelp({contextID: "rqm_add_new_def.html"});
				cshelp.setButtonLabel(Constants.getMessage("labelAddNewDefectHelp"));
				this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
            }
            else {
				if (contextMenuSelection == "existing") {
					var cshelp = new CSHelp({contextID: "rqm_add_exist_def.html"});
					cshelp.setButtonLabel(Constants.getMessage("labelAddExistingDefectHelp"));
					this._defectsViewer.setSecondaryTitleNode(cshelp.domNode);
				}
                this._defectsViewer.open();
                this._defectsViewer.setWidth('800px');
            }
		},

        _initNewDefectForm: function(seedValues) {
            // add in additional details.
            if (this._currentStepNumber >= 0 && this._currentStepNumber < this._steps.length) {
                var stepText = dojo.trim(unescape(this._steps[this._currentStepNumber].content));
				//remove all html tags
				stepText = stepText.replace(/<[^>]*?>/g, "");
                if(stepText.indexOf('<br />') > -1)
                    stepText = stepText.replace("<br />", "");
                if(stepText.length > 128)
                    stepText = stepText.substr(0, 125) + "...";

                seedValues[NewDefectDataInitializer.FAILED_VER_POINT_ATTR] = stepText;
            }
            this._defectView.setViewType("new", seedValues);    
            this._defectsViewer.open();
            this._defectsViewer.setWidth('800px');
        },
        
		_commentIconClicked: function(e){
			var dialogArgs = {
			primaryTitle: this.labelCommentsView,
            isClosable: true,
			okCallback: dojo.hitch(this, function(){
				var properties = this._commentView.getData();
				var commentArea = document.getElementById(this.ID_COMMENT_COL_AREA + this._currentStepNumber);
				if(commentArea)
					commentArea.value = properties[2];
				this.propertiesMap[COMMENT_VIEW_TYPE].elements =this._convertProperties(properties);
				this._updateCurrentStepProps(COMMENT_VIEW_TYPE);
				}),
			cancelCallback: dojo.hitch(this, function(){
				this._comment.focus();
				})
            };                
            this._commentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
            this._commentsViewer.setWidth('600px');
			if(this._commentView)
				this._commentView.destroy();
			this._commentView = new CommentView();
			this._commentView.setData(this.propertiesMap[COMMENT_VIEW_TYPE].elements);
			this._commentsViewer.contentContainer.appendChild(this._commentView.domNode);			
			this._commentsViewer.open();
		},
		
		_checkAndupdateBlockingDefectList: function(isBlocking, oldList, newList){
			if(isBlocking && oldList.length != newList.length){
				var blockingDefectList = newList;
				for(var i=0;i<newList.length;i++){
					for(var j=0;j<oldList.length;j++){
						if(newList[i].propertyValue == oldList[j].propertyValue){
							for(var k=0;k<blockingDefectList.length;k++){
								if(blockingDefectList[k].propertyValue == newList[i].propertyValue){
									blockingDefectList.splice(k,1)
									break;
								}
							}
						}
					}
				}
				var blockingDefectId = blockingDefectList.length > 0 ? blockingDefectList[0].propertyValue : null;
				console.debug("Blocking Defect found - "+blockingDefectId);
				if(blockingDefectId){
					var manuSelf =this;
				    var callbackObj ={
					    success: function(ewi){
					  		manuSelf.ewi = ewi;
					  	},
					  	failure: function(error){
					  		console.error("could not updateEWI with blocking defect "+blockingDefectId +"Error code "+error.message);
					  	}
					}
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");			
					ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, {id: this.ewi.id, ewiStateId:this.ewi.stateId,addDefectIds: [blockingDefectId]});
				}
			}
		},
		_attachmentIconClicked: function(e){             
			if(this._resultAttachmentView)
				this._resultAttachmentView.destroy();
			if(this._attachmentView)
				this._attachmentView.destroy();
			this._attachmentView = new AttachmentView();
			this._resultAttachmentView = new AttachmentView();
			
			this._attachmentView.initialize({hideForm:true});
			var spanAttach = document.createElement("span");
			spanAttach.appendChild(document.createTextNode(Constants.getMessage("labelAttachments")));
			spanAttach.style.fontSize = "11pt";
			spanAttach.style.fontWeight = "bold";
			var spanResultAttach = document.createElement("span")
			spanResultAttach.appendChild(document.createTextNode(Constants.getMessage("labelResultAttach")));
			spanResultAttach.style.fontSize = "11pt";
			spanResultAttach.style.fontWeight = "bold";
			this._attachmentView.setData(this.propertiesMap[ATTACHMENT_VIEW_TYPE].elements);
			this._resultAttachmentView.setData(this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE].elements,this.removedAttachments);
			
			var dialogArgs = {
				primaryTitle: this.labelAttachmentsView,
	            isClosable: true,
				okCallback: dojo.hitch(this, function(){
					this.removedAttachments = this._resultAttachmentView.getRemovedAttachments();
					this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE].elements = 
							this._convertProperties(this._resultAttachmentView.getData(RESULT_ATTACTMENT_VIEW_TYPE));
					this._updateCurrentStepProps(ATTACHMENT_VIEW_TYPE);
				}),
				cancelCallback: dojo.hitch(this, function(){
					this._attachment.focus();
				})
            };			
			this._attachmentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
			this._attachmentsViewer.contentContainer.appendChild(spanAttach);
			this._attachmentsViewer.contentContainer.appendChild(this._attachmentView.domNode);
			this._attachmentsViewer.contentContainer.appendChild(document.createElement("hr"));
			this._attachmentsViewer.contentContainer.appendChild(spanResultAttach);
			this._attachmentsViewer.contentContainer.appendChild(this._resultAttachmentView.domNode);
			this._attachmentsViewer.open();
			//somehow the width doesnt get set correctly unless done after open
			this._attachmentsViewer.setWidth('600px');
		},
		
        ////////////////////////////////
		// Properties related stuff
		////////////////////////////////
        _showCompareDialog:function(stepNum,properties){
			var stepProperties = properties ? properties:this.stepProperties[stepNum];
			if(!stepProperties){
				if(stepNum.indexOf('_')>0){
//					var keywordStepNum = stepNum.split('_')[1];
//					var keywordNum = stepNum.split('_')[0];
//					keywordNum = parseInt(keywordNum,10);
//					var props = this.stepProperties[keywordNum];
//					for(var i=0;i<props.length;i++){
//						if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
//							var propName = props[i].propertyValue.split('#')[0];
//							var propValue = props[i].propertyValue.split('#')[1];
//							stepProperties = [{propertyName:propName,propertyType:COMPARE_VIEW_TYPE,propertyValue:propValue}];
//							break;
//						}
//					}
				}else
					return;
			}
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			dijit.popup.close(this.compareView);
			this.compareView = new CompareView({
				hideActual: false,
				callback: dojo.hitch(this, "_closePopup"),
				callbackData: stepNum
			});
			dojo.style(this.compareView.domNode,"background","white");
			dojo.style(this.compareView.domNode,"border","1px solid gray");
			dojo.style(this.compareView.domNode,"padding","5px");
			dojo.style(this.compareView.domNode,"width","200px");
			this.compareView.setData(stepProperties);
			var self = this;
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onClose: function(){
					dojo._destroyElement(self.compareView.domNode);
				}
			});
			this.compareView.setFocus();
		},
		_closePopup:function(stepNum){
			var changedProperty =this._convertProperties(this.compareView.getData());
			if(stepNum.indexOf && stepNum.indexOf('_')>0){
//				var keywordStepNum = stepNum.split('_')[1];
//				var keywordNum = stepNum.split('_')[0];
//				keywordNum = parseInt(keywordNum,10);
//				var props = this.stepProperties[keywordNum];
//				var propValue = changedProperty[0].propertyName+"#"+changedProperty[0].propertyValue;
//				for(var i=0;i<props.length;i++){
//					if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
//						props[i].propertyValue = propValue;
//						this.uncommittedProperty[keywordNum] = true;
//						break;
//					}
//				}
//				if(keywordNum == this._currentStepNumber){
//					var kwStepProp = this.propertiesMap[KEYWORD_STEP_COMPARE].elements;
//					for(var k=0;k<kwStepProp.length;k++){
//						if(kwStepProp[k].propertyName ==keywordStepNum){
//							kwStepProp[k].propertyValue = propValue;
//							break;
//						}
//					}
//				}
//				if(this.originalStepNum != null)
//                	this._staleStepUpdated = true;
			}else if(stepNum == this._currentStepNumber){
				this.propertiesMap[COMPARE_VIEW_TYPE].elements = changedProperty;
				this._updateCurrentStepProps();
			}
			else{
				if (this.stepProperties[stepNum]) {
					for (var j = 0; j < this.stepProperties[stepNum].length; j++) {
						if (this.stepProperties[stepNum][j].propertyType == COMPARE_VIEW_TYPE) {
							this.stepProperties[stepNum][j].propertyName = changedProperty[0].propertyName;
							this.stepProperties[stepNum][j].propertyValue = changedProperty[0].propertyValue;
							this.uncommittedProperty[stepNum] = true;
							break;
						}
					}
				}
			}
			dijit.popup.close(this.compareView);
		},
		updateCommentProperty:function(changedProperty,stepNum){
			var commentPropertyFound = null;
			if (this.stepProperties[stepNum]) {
					for (var j = 0; j < this.stepProperties[stepNum].length; j++) {
						if (this.stepProperties[stepNum][j].propertyType == COMMENT_VIEW_TYPE) {
							if(changedProperty){
								this.stepProperties[stepNum][j].propertyName = changedProperty.propertyName;
								this.stepProperties[stepNum][j].propertyValue = changedProperty.propertyValue;
								this.uncommittedProperty[stepNum] = true;
							}
							commentPropertyFound = this.stepProperties[stepNum][j];
							break;
						}
					}
				}
			if(changedProperty && !commentPropertyFound){
				if(!this.stepProperties[stepNum])
					this.stepProperties[stepNum] = [];
				this.stepProperties[stepNum].push(changedProperty);	
			}
			var properties= this.stepProperties[stepNum];
			var commentCurr = dojo.byId(this.COMMENT_ID  + stepNum);
			var propshtml = this._createPropertiesHtml(stepNum,properties);
			if(commentCurr)
				commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);
			return commentPropertyFound;
		},
		/*
		 * Called when any dialog is closed from the UI
		 * this.propertiesMap contains the current step only.
		 * After callback success, focus back to property button
		 */
		_updateCurrentStepProps:function(callbackType){
			this.uncommittedProperty[this._currentStepNumber] = true;
			var properties = [];
			for(var propertyType in this.propertiesMap)
				properties = properties.concat(this.propertiesMap[propertyType].elements);
			this.stepProperties[this._currentStepNumber] = properties;
			var attachCurr = dojo.byId(this.ATTACH_ID  + this._currentStepNumber);
			var defectCurr = dojo.byId(this.DEFECT_ID  + this._currentStepNumber);
			var commentCurr = dojo.byId(this.COMMENT_ID  + this._currentStepNumber);
			var compareCurr = dojo.byId(this.COMPARE_ID  + this._currentStepNumber);
			var propshtml = this._createPropertiesHtml(this._currentStepNumber,properties);
			if(attachCurr)
				attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
			if(defectCurr)
				defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
			if(commentCurr)
				commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);
			if(this.originalStepNum != null)
                this._staleStepUpdated = true;
			if(callbackType) {
				switch(callbackType){
					case DEFECT_VIEW_TYPE:
					case RTC_DEFECT_VIEW_TYPE:
						this._defect.focus();
						break;
					case ATTACHMENT_VIEW_TYPE:
					case RESULT_ATTACTMENT_VIEW_TYPE:
						this._attachment.focus();
						break;
					case COMMENT_VIEW_TYPE:
						this._comment.focus();
						break;
					case COMPARE_VIEW_TYPE:
					default:
						//do Nothing
				}
			}
		},

		setProperties: function(properties){
			if(!this.propertiesMap)
				this.propertiesMap = [];
			this.propertiesMap[ATTACHMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[DEFECT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[RTC_DEFECT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[COMMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[COMPARE_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[KEYWORD_TYPE] = {elements:[]};
			this.removedAttachments = undefined;
			if(properties){
				for (var i = 0; i < properties.length; i++) {
					if(!this.propertiesMap[properties[i].propertyType])
						this.propertiesMap[properties[i].propertyType] = {elements:[]};
					this.propertiesMap[properties[i].propertyType].elements.push(properties[i]);
				}
			}
			if(this.propertiesMap[COMPARE_VIEW_TYPE] && this.propertiesMap[COMPARE_VIEW_TYPE].elements.length >0)
				this._showCompareDialog(this._currentStepNumber,this.propertiesMap[COMPARE_VIEW_TYPE].elements);
		},
		
		_convertProperties:function(properties){
			var elements = [];
			if(properties){
				for(var i=0;i<properties.length;i=i+3 ){
					var property = {
						propertyType: properties[i],
						propertyName: properties[i+1 ],
						propertyValue: properties[i+2 ]
					}
					if(property.propertyValue != null && property.propertyValue.length>0)
						elements.push(property);
				}
			}
			return elements;
		},

		getProperties:function(){
			var stepProps = [];
			for(var propertyType in this.propertiesMap)
				stepProps = stepProps.concat(this.propertiesMap[propertyType].elements);
            return stepProps;
		},
		
		_convertPropertiesViaProvider: function(draftLinkParams) {
			var property = {
				propertyType: RTC_DEFECT_VIEW_TYPE,
				propertyName: draftLinkParams.summary,
				propertyValue: draftLinkParams.url
			}
			return property; 
		},
		
		_showDefectViaProvier: function(properties) {
			var draftUriFilter = [];
			for(var i = 0; i < properties.length; i++){
				draftUriFilter.push(
					properties[i].propertyValue
				);
			}
			var listDialog= AssociatedWorkItemViewer.create(this.ewiItemId, CmIntegrationClient.RESULT_RELATEDTO_DEFECT, false, draftUriFilter);
		},
		_toggleCommentsColumn:function(){
			this.showCommentsCol = !this.showCommentsCol;
			if (this.showCommentsCol) {
				dojo.style(this.comments_col_header, 'display', '');
				dojo.style(this.comments_col, 'display', '');
				for(var i=0;i<this._steps.length;i++){
					var commentAreaCell = document.getElementById(this.ID_COMMENT_COL_CELL+i);
					if(commentAreaCell)
						dojo.style(commentAreaCell,'display','');
					var commentCell = document.getElementById(this.COMMENT_ID+i);
					if(commentCell)
						dojo.style(commentCell,'display','none');
				}
			}else{
				dojo.style(this.comments_col_header, 'display', 'none');
				for(var i=0;i<this._steps.length;i++){
					var commentAreaCell = document.getElementById(this.ID_COMMENT_COL_CELL+i);
					if(commentAreaCell)
						dojo.style(commentAreaCell,'display','none');
					var commentCell = document.getElementById(this.COMMENT_ID+i);
					if(commentCell)
						dojo.style(commentCell,'display','');
						
				}
				dojo.style(this.comments_col, 'display', 'none');
			}
		},
		_buildDefectIdList: function(properties){
            var defectIdList = [];
            if (properties) {
                for (var i = 0; i < properties.length; i++) {
                    if (properties[i].propertyType == DEFECT_VIEW_TYPE && properties[i].propertyValue != null) 
                        defectIdList.push(properties[i].propertyValue);
                }
            }
            return defectIdList;
		},
        
		_buildAttachmentIdList: function(properties){
            var attachmentIdList = [];
            if (properties) {
                for (var i = 0; i < properties.length; i++) {
                    var type = properties[i].propertyType
                    if (type == ATTACHMENT_VIEW_TYPE || type == RESULT_ATTACTMENT_VIEW_TYPE) {
                        var value = properties[i].propertyValue.split(":");
                        if (value.length > 3) 
                            attachmentIdList.push(value[3]);
                    }
                }
            }
            return attachmentIdList;
		},
		_displayAlertDialog: function(message){
            var args = {
				message: message
			}
			var alertDialog = new AlertDialog( args );
            alertDialog.open();
        }
});
})();	
