//SequenceEditor
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
(function() {
var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AbstractEditor 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceEditor", [dijit._Widget, dijit._Templated, AbstractEditor],
{
		templateString: '<div>' +
						'    <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" dojoAttachPoint="_header"' +
                	    '         summaryEditable="true" summaryAsDesc="false">' +
						'    <div dojoAttachPoint=\"overviewSection\"></div>'+
						'    <div dojoAttachPoint=\"sequenceSection\"></div>'+
						'    </div>' +
						'</div>',
		
		widgetsInTemplate: true,
		_initialized: false,
		_sequenceType: Constants.SEQUENCE_TYPE_SCHEDULE,
		
		postCreate: function(){
		},
		
		initialize: function(){
			dojo.deprecated("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor is deprecated and will be removed post 2.0");
			this._initialized = false;
			if(this.sequenceId){
				var responseHandler = new ServiceResponseHandler(this, "_createLayout", "_error");
				SequenceClient.getExecutionSequencesDTO(responseHandler, {id: this.sequenceId});
			}else{
				this._createLayout();//New Sequence
			}
		},

		_createLayout: function(sequence){
			if(sequence && sequence.length == 1){
				this.setArtifact(sequence[0]);
			}
			this.sections = [];
			this.setArtifactType(Constants.TYPE_SEQUENCE);
			this.setNew(this.getArtifact() ? false : true);
			this._defaultName = Constants.getMessage("labelNewSequenceTitle");
			this.createHeader({title: (this.getArtifact() ? this.getArtifact().name : ""),
												iconClass: "sequence-def-icon-48",
												csHelpId: "rqm_cre_exec_sequence.html"});
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelExecutionSequence")+" "+Constants.getRQMMessage("labelHelp"));
            if(this.getArtifact() &&
                this.getArtifact().scheduledStart == null && 
                this.getArtifact().associatedBuildDef) {            
                this.setSequenceType(Constants.SEQUENCE_TYPE_BVT);        
            }
												
			this.setOriginator(this.getArtifact() ? this.getArtifact().originator.name : null);
			this.setOwner(this.getArtifact() ? this.getArtifact().owner.itemId : null);
			var inputArguments = {parentEditor: this};
			this.overviewWidget = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection(inputArguments);
			this.overviewWidget.initialize();
			this.sequenceWidget = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.ExecutionSequenceSection(inputArguments);
			var csHelpLabel = Constants.getMessage("labelOverview")+" "+Constants.getRQMMessage("labelHelp");
			this.createSection(this.overviewSection, {title: Constants.getMessage("labelOverview"), info: Constants.getMessage("labelOverviewSummary"), widget: this.overviewWidget, csHelpId: "sequence_overview.html",csHelpLabel:csHelpLabel});
			var csHelpLabel1 = Constants.getMessage("labelExecSequence")+" "+Constants.getRQMMessage("labelHelp");
			var seqSection = this.createSection(this.sequenceSection, {title: Constants.getMessage("labelExecSequence"), info: Constants.getMessage("labelExecSequenceSummary"), widget: this.sequenceWidget, addPlaceHolder: true, csHelpId: "sequence_steps.html",csHelpLabel:csHelpLabel1});
			this.currentSectionNode = seqSection.appendableDomNode;
			
			if(this.getArtifact()){
				var steps = this.getArtifact().steps;
				for(var i=0;i< (steps ? steps.length : 0);i++){
					var sequenceStep = {}
					if(steps[i].stepType == Constants.TYPE_TEST){
						var record = this._convertToSuiteFormat(steps[i].executionRecord);
						record = this._createProxyResultGroup(record, steps[i]);//HACK should be done on server side.
						var attributes = {
							type: steps[i].executionRecordType,
							record: record
						}
						var args = {
							attributes: attributes,
							type: Constants.TYPE_TEST
						}
						this.sequenceWidget.addRowInStepTable(args);
					}else{//Automation
					
					var automation ={jobs: [], machines: []}
					var automationName = steps[i].automationName ? steps[i].automationName : Constants.getMessage("labelUnassigned");
					var machineName = steps[i].machineName ? steps[i].machineName : Constants.getMessage("labelUnassigned");
					automation.jobs.push({
											jobId: steps[i].jobId, 
											jobName: automationName, 
											providerInstance: steps[i].providerInstance, 
											providerName: steps[i].providerName, 
											parameters: steps[i].parameters
										});
					var machine = {};
					machine["machine.id"] = steps[i].assetId;
					machine["machine.name"] = machineName;
					automation.machines.push(machine);
					
					var attributes = {
							type: Constants.TYPE_AUTOMATION,
							automation: automation
						}
						var args = {
							attributes: attributes,
							type: Constants.TYPE_AUTOMATION
						}
						this.sequenceWidget.addRowInStepTable(args);
					}
				}
			}
			
			this._createContentArea(inputArguments);
			dojo.connect(this, "setSequenceType", this, "updateExecutionSequenceSection");
			this.updateBrowserTitle();
            this._initialized = true;
            // The saved test cell will be loaded asynchronously after it is fetched by id.      
            if(this.getArtifact() && this.getArtifact().testCellId) {            
                this.overviewWidget.loadTestCell(this.getArtifact().testCellId);
            }
		},
				
		_createContentArea: function(inputArguments){
			dojox.data.dom.removeChildren(this.currentSectionNode);
		},
		
		_createAutomationSection: function(index, inputArguments, replaceCurrentNode){
			inputArguments.sectionIndex = index;
			var automation = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.AutomationSection(inputArguments); 
			if(replaceCurrentNode){
				dojox.data.dom.removeChildren(this.currentSectionNode);
			}
			this.concatSection(index, automation);
		},
		
		_createTestRecordSection: function(index, inputArguments, replaceCurrentNode){
			inputArguments.sectionIndex = index;
			var testRecord = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.TestRecordView(inputArguments);
			var node = null;
			if(replaceCurrentNode)
				node = this.currentSectionNode;
			var title = inputArguments && inputArguments.details && inputArguments.details.attributes && inputArguments.details.attributes.type == Constants.MODEL_TYPE_SUITE ? Constants.getMessage("labelTestSuite") : Constants.getMessage("labelTestExecutionRecord");
			this.createSection(node, {title: title, info: Constants.getMessage("labelTestRecordSummary", title), widget: testRecord});
			this.concatSection(index, testRecord);
		},
		
		getSequenceType: function(){
			return this._sequenceType;
		},
		
		setSequenceType: function(seqType){
			this._sequenceType = seqType;
		},
		
		updateExecutionSequenceSection: function(){
			this.sequenceWidget.initialize();
			this.sections = [];
			this._createContentArea({parentEditor: this});
		},
		
		updateContentArea: function(args){
			var section = null;
			if (!args) {
				dojox.data.dom.removeChildren(this.currentSectionNode);
				return;
			}
			if(args.sectionIndex || args.sectionIndex == 0){
				section = this.getSection(args.sectionIndex);
			}else if(args.sectionId){
				for(var i=0;i<this.sections.length;i++){
					if(this.sections[i].id == args.sectionId){
						section = this.sections[i];
						break;
					}
				}
			}
			if(section){
				dojox.data.dom.removeChildren(this.currentSectionNode);
				if(args.id == Constants.AUTOMATION_ID){
//					this.currentSectionNode.appendChild(section.domNode);
				}else{
					this.currentSectionNode.appendChild(section.containerSection.domNode);
					section.onActivated();
				}
			}
		},

		//Over-ridden from _AE
		validate: function(){
			var name = this.getHeader().getTitle();
            if (dojo.trim(name).length == 0) {
                if (this.isNew()) {
                    this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
						Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelExecutionSequence")));
					return false;
                } else {
                    this.getHeader().setTitle(this.getArtifact().name);
                }
            } else if (this._defaultName && name == this._defaultName) {
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR,
					Constants.getMessage("msgRequiredField", Constants.getMessage("labelName"), Constants.getMessage("labelExecutionSequence")));
                return false;
            }
			if(this.getSequenceType() == Constants.SEQUENCE_TYPE_BVT && this.overviewWidget.getBuildUUID() == null){
				this.setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.getMessage("msgInvalidBuildDef"));
				return false;
			}
            return true;
		},
		
		//Over-ridden from _AE
		getAttributes: function(){
			var testObj = this.inherited('getAttributes', arguments);
			if(this.isNew())
				testObj.isNewItem = true;
			else{
				var artifact = this.getArtifact();
				testObj.id = artifact.id;
				testObj.itemId = artifact.uuid;
				if(artifact.stateId)
					testObj.stateId = artifact.stateId;
			}	
			testObj.name = this.getHeader().getTitle();
			testObj.description = "";
			if(this.getOwner().value != Constants.getMessage("labelUnassigned")){
				testObj.owner = this.getOwner().value; 
			}
			if(this.getSequenceType() == Constants.SEQUENCE_TYPE_BVT){
				testObj.isBVTSequence = true;
				testObj.buildDefId = this.overviewWidget.getBuildUUID();
				testObj.runOnFailedBuild = this.overviewWidget.isRunOnFailedBuild();
			}else{
				testObj.isBVTSequence = false;
				testObj.scheduledExecutionTime = this.overviewWidget.getScheduledTime();
			}
			if (this.overviewWidget.testCellItemId != null) {
			    testObj.testCellId = this.overviewWidget.testCellItemId;
			}
			return testObj;
		},
		
		_convertToSuiteFormat: function(testSuite){
			 if(testSuite && testSuite.elements && testSuite.elements.length >0){
			 	for(var i=0;i<testSuite.elements.length;i++){
					testSuite.elements[i].workitem = {};
					testSuite.elements[i].workitem.id = testSuite.elements[i].ewiId;
					testSuite.elements[i].workitem.name = testSuite.elements[i].ewiName;
					testSuite.elements[i].workitem.itemId = testSuite.elements[i].ewiitemId;
					testSuite.elements[i].workitem.archived = testSuite.elements[i].ewiIsArchived;
					testSuite.elements[i].workitem.testCase = testSuite.elements[i].testCase;
					testSuite.elements[i].workitem.weight = testSuite.elements[i].ewiWeight;
					if(testSuite.elements[i].ewiPlanId){
						testSuite.elements[i].workitem.testPlan = {};
						testSuite.elements[i].workitem.testPlan.id = testSuite.elements[i].ewiPlanId;
						testSuite.elements[i].workitem.testPlan.name = testSuite.elements[i].ewiPlanName;
						testSuite.elements[i].workitem.testPlan.versionableItemId = testSuite.elements[i].ewiPlanVersionableItemId;
					}	
					if(testSuite.elements[i].ewiPhaseName){
						testSuite.elements[i].workitem.testPhase = {};
						testSuite.elements[i].workitem.testPhase.name = testSuite.elements[i].ewiPhaseName;
						testSuite.elements[i].workitem.testPhase.itemId = testSuite.elements[i].ewiPhaseItemId;
					}
					if(testSuite.elements[i].scriptId){
						testSuite.elements[i].script = {};
						testSuite.elements[i].script.id = testSuite.elements[i].scriptId;
						testSuite.elements[i].script.name = testSuite.elements[i].scriptName;
						testSuite.elements[i].script.itemId = testSuite.elements[i].scriptItemId;
						testSuite.elements[i].script.stateId = testSuite.elements[i].scriptStateId;
						testSuite.elements[i].script.scriptType = {};
						testSuite.elements[i].script.scriptType.id = testSuite.elements[i].scriptTypeId;
					}
					if(testSuite.elements[i].ewiDefaultScriptId){
						testSuite.elements[i].workitem.defaultScript = {};
						testSuite.elements[i].workitem.defaultScript.id = testSuite.elements[i].ewiDefaultScriptId;
						testSuite.elements[i].workitem.defaultScript.name = testSuite.elements[i].ewiDefaultScriptName;
						testSuite.elements[i].workitem.defaultScript.itemId = testSuite.elements[i].ewiDefaultScriptItemId;
						testSuite.elements[i].workitem.defaultScript.stateId = testSuite.elements[i].ewiDefaultScriptStateId;
						testSuite.elements[i].workitem.defaultScript.scriptType = {};
						testSuite.elements[i].workitem.defaultScript.scriptType.id = testSuite.elements[i].ewiDefaultScriptTypeId;
					}else{
						testSuite.elements[i].workitem.defaultScript = null;
					}	
					testSuite.elements[i].workitem.stateId = testSuite.elements[i].ewiStateId;
					testSuite.elements[i].workitem.configuration = testSuite.elements[i].ewiConfigurationItemId;
					
					delete testSuite.elements[i].ewiId;
					delete testSuite.elements[i].ewiName;
					delete testSuite.elements[i].ewiitemId;
					delete testSuite.elements[i].ewiIsArchived;
					delete testSuite.elements[i].testCase;
					delete testSuite.elements[i].ewiDefaultScriptId;
					delete testSuite.elements[i].ewiDefaultScriptName;
					delete testSuite.elements[i].ewiDefaultScriptItemId;
					delete testSuite.elements[i].ewiDefaultScriptStateId;
					delete testSuite.elements[i].ewiDefaultScriptTypeId;
					delete testSuite.elements[i].ewiConfigurationItemId;
					delete testSuite.elements[i].ewiStateId;
					delete testSuite.elements[i].ewiPlanId;
					delete testSuite.elements[i].ewiPlanName;
					delete testSuite.elements[i].ewiPlanVersionableItemId;
					delete testSuite.elements[i].ewiPhaseItemId;
					delete testSuite.elements[i].ewiPhaseName;
					delete testSuite.elements[i].ewiWeight;
					
					delete testSuite.elements[i].scriptId;
					delete testSuite.elements[i].scriptName;
					delete testSuite.elements[i].scriptItemId;
					delete testSuite.elements[i].scriptStateId;
					delete testSuite.elements[i].scriptTypeId;
				}
			 }
			return testSuite;
		},
		
		//This data will get passed on inSelectionPopup see TestRecordCView#_updateDetailsWith.. functions
		_createProxyResultGroup: function(suite, data){
			if(!(data.adapters && data.adapters.length > 0 )){
				data.adapters = [];
			}
			if(data && data.scripts && data.scripts.length > 0){
				suite.currentResultGroup = {};
				suite.currentResultGroup.description = "custom";
				suite.currentResultGroup.elements = [];
				for(var i=0;i<data.scripts.length;i++){
					var index = i;
					var ewiId = null;
					if(suite.elements /*TER will not have elements*/){
						//Suite
						ewiId = suite.elements[i].workitem.id;
						index = suite.elements[i].index;
					}else{
						//TER
						ewiId = suite.id;//In this case the script will be one, index will be 0
					}
					//@Map back from SelectionPopUp#initialize()
					suite.currentResultGroup.elements[i] = {};
					suite.currentResultGroup.elements[i].ewiId = ewiId;
					suite.currentResultGroup.elements[i].index = index;
					suite.currentResultGroup.elements[i].scriptItemId = data.scripts[i].versionableItemId;
					suite.currentResultGroup.elements[i].scriptTypeId = data.scripts[i].scriptTypeId;
					suite.currentResultGroup.elements[i].scriptName = data.scripts[i].name;
					suite.currentResultGroup.elements[i].adapterId = (data.adapters[i] && data.adapters[i].id) ? data.adapters[i].id : 0; 
				}
			}
			return suite;
		},
		
		onActivated: function(){
			this.inherited(arguments);
			if(this.sequenceWidget)
				this.sequenceWidget.onActivated();
		},
		
		// handler on artifacts changed
        onArtifactChanged: function(changeType, artifactType, artifactArray) {
            if (artifactType == Constants.TYPE_SEQUENCE) {
                for (var i = 0; i < artifactArray.length; i++) {
                    if (this.getArtifact() && (this.getArtifact().id == artifactArray[i].id)) {
                        if (changeType == GlobalEvents.ArtifactsDeleted){
							this.getHeader().setStatus(Constants.getMessage("msgEditorExecSequenceDeleted"), ViewHeaderLayout.ERROR);
							this.setArchived(true);
	                        return;
						}		
                    }
                }
            }
        },
		
		getCell: function(){
			if(!this.overviewWidget)
				return null;
			return this.overviewWidget.getCellObject();
		},
		
		getStepTableContent: function(){
			if(this.sequenceWidget){
				return this.sequenceWidget.getStepTableContent();
			}
		},
		
		setStepTableContent: function(content){
			if(this.sequenceWidget){
				this.sequenceWidget.setStepTableContent(content);
			}
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from SequenceEditor#_error");
		}
	}
);
}
)();
		
