/**BuildTable***************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView")
dojo.provide("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil");
dojo.require("com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var BuildUiUtil				= com.ibm.rqm.buildintegration.web.ui.internal.BuildUiUtil;
var ImageCache				= com.ibm.rqm.buildintegration.web.ui.internal.view.build.ImageCache;
var CommonImageCache		= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

dojo.declare("BuildTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	constructor: function(parentView) {
        this.parentView = parentView;
    },
    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode && this.parentView.editable)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
		//if table view has a rowCheckListener, invoke it
        var p = this.parentView;
        if (p && p.rowCheckedListener && dojo.isFunction(p.rowCheckedListener) && p.editable) {
            p.rowCheckedListener(rowObject, state);
        }	
		
	},
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData))
            callbackData();		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null)
                callback(callbackData);
            else
                callback();
        } 
    }
});
dojo.declare("BuildTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol >-1 && this.sortCol == 5){
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND)
				return dojo.date.compare(obj1.endTime,obj2.endTime);
			else
				return dojo.date.compare(obj2.endTime,obj1.endTime);
		}
		else 
			return this.inherited("_sortComparator",arguments);
	},
	_groupComparator: function(obj1, obj2){
		var val1 = this.viewer.getContentProvider().getCellDisplayData(obj1, this.groupCol);
		var val2 = this.viewer.getContentProvider().getCellDisplayData(obj2, this.groupCol);
		if(val1 == val2) {
		// there's a secondary sort and it's not the same as the group
		// sort column, sort by it.
		if(this.sortCol > -1 && this.groupCol != this.sortCol)
			return this._sortComparator(obj1, obj2);

		return 0;
		}
		if(this.groupCol == 5)
			return dojo.date.compare(obj1.endTime,obj2.endTime);
		else
			return this.inherited("_groupComparator",arguments);
	}
});

dojo.declare("BuildTableView.TableContentProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
	constructor: function(min_profile) {
        this.min_profile = min_profile;
    },
    getNumColumns: function(content){
		if(this.min_profile != null)
			return 5;
        return 8;
    },
    getColumnHeading: function(content, index){
		if(this.min_profile != null){
			var headings = [
				"",
	            BuildUiUtil.getMessage("labelStatus"),
				BuildUiUtil.getMessage("labelState"),
				BuildUiUtil.getMessage("labelBuild"),
				BuildUiUtil.getMessage("labelDescription")
			];
		}else{
	        var headings = [
				"",
	            BuildUiUtil.getMessage("labelStatus"),
				BuildUiUtil.getMessage("labelState"),
				BuildUiUtil.getMessage("labelBuild"),
				BuildUiUtil.getMessage("labelDescription"),
				BuildUiUtil.getMessage("labelCompletionTime"),
				BuildUiUtil.getMessage("labelBvtStatus"),
				BuildUiUtil.getMessage("labelTestsRun")
	        ];
		}	
        return headings[index];
    },
    getIsColumnVisible: function(atColumnIndex) {
        return atColumnIndex != 6 && // disable BVT Status by default
        atColumnIndex != 7; // disable Tests Run by default
    },
    
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    getIsColumnGroupable: function(content, atColumnIndex){
		return (atColumnIndex != 4 && atColumnIndex != 7 && atColumnIndex !=0);
    },
    getIsColumnSortable: function(content, atColumnIndex){
        return (atColumnIndex != 4 && atColumnIndex != 7 && atColumnIndex !=0);     
    },
    getColumnWidth: function(content, atColumnIndex){
		if (this.min_profile != null) {
			switch (atColumnIndex) {
				case 0:
					return 5;
				case 1:
					return 5;
				case 2:
					return 5;
				case 3:
					return 45;
				case 4:
					return 40;
			}
		}
		else {
			switch (atColumnIndex) {
				case 0:
					return 5;
				case 1:
					return 5;
				case 2:
					return 5;
				case 3:
					return 10;
				case 4:
					return 30;
				case 5:
					return 15;
				case 6:
					return 15;
				case 7:
					return 15;
			}
		}
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "build_table_row_" + rowData.id;
    },
   
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		switch(atColumnIndex){
			case 1:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
			case 2:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
			case 3:
				type = TableConstants.RENDER_TYPE_LINK;
				break;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex){
		var val = "";
		switch (atColumnIndex) {
			case 1:
				val = rowData.status? BuildUiUtil.getDisplayName(rowData.status.stateId,rowData.status.displayName):"";
				break;
			case 2:
				val = rowData.state? BuildUiUtil.getDisplayName(rowData.state.stateId,rowData.state.displayName):"";
				break;
			case 3:
				val = rowData.name || "";
				break;
			case 4:
				val = rowData.description || "";
				break;
			case 5:
				val = rowData.completedAt;
				break;
			case 6:
				val = ""; // disabled per work item 18174
				break;
			case 7:
				val = ""; // disabled per work item 18174
				break;
		}
        return val;				       
    },
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = {};
		switch(atColumnIndex){
			case 1:
				if(rowData.status && (rowData.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.ok" || rowData.status == "OK")){
					val.image = CommonImageCache.PASS_ICON;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelOK"));
				}
				else if(rowData.status && (rowData.status.stateId == "com.ibm.rqm.buildintegration.buildstatus.error" || rowData.status == "Error")){
					val.image = CommonImageCache.ERROR_ICON;
					val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelError"));
				}else
					val.image = CommonImageCache.NOIMAGE;
				break;
			case 2:
				if (rowData.state) {
					if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstate.complete" || rowData.status.displayName == "Complete") {
						val.image = ImageCache.BUILD_COMPLETED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelComplete"));
					}else if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstate.running" || rowData.status.displayName == "Running") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelRunning"));
					}else if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstate.inprogress" || rowData.status.displayName == "In Progress") {							
						val.image = ImageCache.BUILD_RUNNING;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelInProgress"));
					}else if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstate.queued" || rowData.status.displayName == "Queued") {
						val.image = ImageCache.BUILD_QUEUED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelQueued"));
					}else if (rowData.state.stateId == "com.ibm.rqm.buildintegration.buildstate.cancelled" || rowData.status.displayName == "CANCELLED") {
						val.image = ImageCache.BUILD_CANCELLED;
						val.tooltip = BuildUiUtil.getMessage("msgBuildState", BuildUiUtil.getMessage("labelCancelled"));
					}else
						val.image = CommonImageCache.NOIMAGE;
				}
				break;
			case 3:
				val.href = BuildUiUtil.getBuildRecordURI(rowData.id);
		}
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.buildintegration.web.ui.internal.view.table.BuildTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '</div>',

    widgetsInTemplate: false,
	rowCheckedListener:null,
	tableRowsCheckable:null,
	min_profile:null,
	editable:true,
    constructor: function(args) {
		this.actions = args.actions?args.actions:[];
		this.tableRowsCheckable = args.tableRowsCheckable;
		this.min_profile = args.min_profile;
		this.editable = args.editable;
		this.consoleNode = args.consoleNode;
	 },

    postCreate: function(){
		var allowAdjustSettings = this.min_profile?false:true;
		var args = {autoSaveSettings:allowAdjustSettings,allowAdjustSettings:allowAdjustSettings}
		if(!this.min_profile){
			args.sortByColumn = 5;
			args.sortDir= TableConstants.SORT_DIR_DESCEND;
		}
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer(args);
		if(allowAdjustSettings)
			this.tableViewer.tableId = this.consoleNode? "RQM-BUILD-RECORD-TABLEVIEWER":"RQM-BUILD-QUERY-TABLEVIEWER";
        this._tableViewerNode.appendChild(this.tableViewer.domNode);	
        this.tableViewer.showLoadingProgress();
		this.tableViewer.setContentPageSize(20);
        this.tableViewer.setContentProvider(new BuildTableView.TableContentProvider(this.min_profile));
		this.tableViewer.setTableListener(new BuildTableView.TableListener(this));
		this.tableViewer.setSorter(new BuildTableView.Sorter());
		this.tableViewer.setTableSummary(BuildUiUtil.getMessage("labelTableSummary", BuildUiUtil.getMessage("labelAllBuilds")));
        this.tableViewer.setTableRowsCheckable(this.tableRowsCheckable, (this.singleSelectable ? this.singleSelectable : false));
		this.refreshBtn = this.addAction({
				name:"refresh", label:BuildUiUtil.getMessage("labelRefresh"), 
				context:this, icon:"refresh-icon-image",callback: dojo.hitch(this, "refresh")});
		for(var i=0;i<this.actions.length;i++){
			var actionBtn = this.addAction(this.actions[i]);
			if(!this.editable)
				actionBtn.setDisabled(true);
		}
		this.setContent(this.builds);
		this.tableViewer.endLoadingProgress();
    },
	addAction:function(action){
		if(action.name == "removeBuildRec"){
			this.deleteActionNode = this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback); 
			this.deleteActionNode.setDisabled(true);
			return this.deleteActionNode;
		}else
			return this.tableViewer.addAction(action.name,action.label,action.context,action.icon,action.callback);
	},
	show:function(){
		this.tableViewer.show();
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	},
	setContent:function(content){
		this.builds = content? content:[];
		for(var i=0; i < this.builds.length;i++){
			if (this.builds[i].endTime && Number(this.builds[i].endTime) != NaN && this.builds[i].endTime != 0) {
				this.builds[i].completedAt = this._convertLongToDate(this.builds[i].endTime);
				if (this.builds[i].completedAt == "") 
					this.builds[i].endTime = 0;
			}else {
				this.builds[i].completedAt = "";
				this.builds[i].endTime = 0;
			}
		}
		this.tableViewer.setContent(this.builds);	
	},
	refresh:function(){
		this.tableViewer.showLoadingProgress();
		if(this.parentController){
			this.refreshBtn.setDisabled(true);
			this.parentController.initialize();
		}
		this.tableViewer.endLoadingProgress();
	},
	refreshTable:function(content){
		this.setContent(content);
		this.tableViewer.refresh();
		this.refreshBtn.setDisabled(false);
	},
	_convertLongToDate: function(/*accepts long*/longDate){
		var date = new Date();
		date.setTime(longDate);
		if(date == "Invalid Date")
			return "";
		return dojo.date.locale.format(date, {formatLength: "medium"});
		
	},
	getSelectedRows:function(){
		return this.tableViewer.getCheckedRows();
	}
});

})();
