//TESelectorDialog
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

( function() {
	
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;		
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
		
dojo.declare("TESelectorDialog.TableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 3;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
			"",
            RtlmUiUtil.getMessage("cfgName"),
            RtlmUiUtil.getMessage("reqLabel_description")
        ];
        return headings[index];
    },

	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return atColumnIndex > 0;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
			case 0:
				return 1;
            case 1: 
                return 34;
            case 2: 
                return 65;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
 			case 0:
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.name;
                break;
            case 2: 
                if(rowData.summary != null)
                    val = rowData.summary;
                break;          
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
			val['image'] = ImageCache.CONFIGURATION_ICON;
        }

        return val;
    }  
    
    
});

	
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.configurations.TESelectorDialog",
			 com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog,
{	
    width: "70%",
	isSingleSelect: true,
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );

        if (this.title) {
            this.setTitle(this.title);
        }

        //Create the table that will hold the assets
        this.createTable();
        this.loadTable();
        this._checkButtonStatus();
		
		//Add the contents to the dialog
		this.contentContainer.appendChild( this.tableViewer.domNode );		
	},
	
	//allow the user to specify a callback when OK is clicked
	setOKAction :function(callback)
	{
		this.yesCallback = callback;
	},
	
    //allow the user to specify a callback when Cancel is clicked
    setCancelAction :function(callback)
    {
        this.noCallback = callback;
    },
	
	getSelectedIDs: function()
	{
		var itemIds = [];
		var rows = this.tableViewer.getCheckedRows();
		for(var i = 0; i < rows.length; i++) {
			if (rows[i].id != null) {
				itemIds.push(rows[i].id);
			}
		}
		return itemIds;	
	},
	
	getSelectedItems: function()
	{
		return this.tableViewer.getCheckedRows();		
	},
	
    show: function() {
        this.open();
    },
    
	createTable: function()
	{
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.tableContentProvider = new TESelectorDialog.TableProvider();
		this.tableViewer.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("labelAsset")));
				
		this.tableViewer.setTableRowsCheckable( true, this.isSingleSelect );

		this.tableViewer.setContentProvider( this.tableContentProvider );
		this.tableViewer.setTableListener( this );

        this._clearTable();        
	},
	
	loadTable: function()
	{
        this.tableViewer.showLoadingProgress();

        var TEs = new com.ibm.rational.test.lm.web.client.internal.config();
        var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_searchSuccess", "_searchError");
    
        TEs.getAll(responseHandler);
		        
	},
	
	_searchSuccess: function( response )
	{
        this.tableViewer.noItemMessage = "";
        this.tableViewer.endLoadingProgress();
        this.tableViewer.setContent( response );
        this.tableViewer.show();
        this.updatePosition();
	},
	
	_searchError: function( message, error )
	{
        this.tableViewer.endLoadingProgress();
        this.tableViewer.noItemMessage = RtlmUiUtil.getMessage("errRetrieveAllConfigs");
        this.tableViewer.setContent([]);
        this.tableViewer.show();
	},
	
	_clearTable: function()
	{
        // loads an empty content to the table to clear the content.
        var emptyContent = [];
        
        // don't show the standard empty content message. This is intensional
        // to have an empty content in the table.
        this.tableViewer.noItemMessage = " ";
        this.tableViewer.setContent(emptyContent);
        this.tableViewer.show();
	},
	
	
	// a row was checked so lets enable and disable actions appropriately    
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
    	this._checkButtonStatus();
    },

	//Enable the OK button when a row is selected	
	_checkButtonStatus: function()
	{
		var rows = this.tableViewer.getCheckedRows();
        this._yesButton.disabled = (!rows || rows.length == 0);
	}				
});

})();

